#use blib;
use PDL;
use Mylib::Astrom;

print "====> catalog cross correlation\n";

my $ra=double[10.111,9.01,23.44,9.21];
my $rd=double[-1.22,10.44,89.00, 11];
my $ta=double [9.00, 22.44, 12,9.21];
my $td=double[10.4, 88.5, -1.1, 11];

print "$ra\n";

my ($xi, $m, $n)=&Mylib::Astrom::_matchCats($ra, $rd, $ta, $td, 1);

$n--;
print $xi->slice("0:$n"),"   ",$m->slice("0:$n"), "\n";


my ($xi, $m)=&Mylib::Astrom::matchCats($ra, $rd, $ta, $td, .1);

print "=> $xi  $m \n";

print "=======================\n";

my ($xi, $m, $nf, $n)=&Mylib::Astrom::_NmatchCats($ra, $rd, $ta, $td, 1,0);

$n--;
print $xi->slice("0:$n"),"   ",$m->slice("0:$n"), "    ",$nf->slice("0:$n"), "\n";


my ($xi, $m, $nf)=&Mylib::Astrom::NmatchCats($ra, $rd, $ta, $td, 1);

print "=> $xi  $m $nf\n";

die;

print "===> Precession and format conversion of coordinates\n"; 
my ($ain, $din)=(10.22,-14.199999933333333);


($ra, $dec)=precess($ain,$din, 1950.,2000.);
print "$ain $din => $ra $dec\n";

#my ($ra, $dec)=&Mylib::Astrom::sexag($ain*15, $din);
my ($ra)=&Mylib::Astrom::sexag($ain);
my ($dec)=&Mylib::Astrom::sexag($din, '\sig');

#my $dec=&Mylib::Astrom::sexag($din);

print " => $ra $dec\n";

# ================ test the PV routines

print "===> PV routines\n";

my $order=4;
my $ncoeffs=&Mylib::Astrom::calcNcoeffs($order);
print "calcNcoeffs gives $ncoeffs coeffs for order $order\n";

my $order=4;
my $dsol=$order*$order+1;
print "Testing cvpol with order $order\n";
 for (my $sidx=0;$sidx<$dsol;$sidx++) {
      my $nidx=&Mylib::Astrom::cvpol($sidx, $order);
	print "    $sidx -> $nidx\n"
      }   
 


sub tsexag
{

my $dec=shift;
my $arg='';

if ($#_ >=0) {$arg=lc(shift)}
 
  my $tval=$dec;
  my $sig=$tval/abs($tval);
  my $v1=int($tval);
  my $v3=abs($tval-$v1)*60.;
  my $v2=int($v3);

  $v3=int( ($v3-$v2)*60.*100+.5)/100.;

  if ($v3>=60) {
     $v3-=60; $v2++;    
  }

  if ($v2>=60) {$v2-=60; $v1+=$sig};

  my $sex=sprintf "%02d:%02d:%05.2f", abs($v1), $v2, $v3;

  if ($sig==-1)  {$sex='-'.$sex}
  elsif ($arg eq '\sig' && $v1 !~ /^-/ && $v1 >=0) {$sex='+'.$sex}

return $sex;

}

