 /*
 				define.h

*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*
*	Part of:	SkyMakerII
*
*	Author:		E.BERTIN, LDAC/DeNIS
*
*	Contents:	global definitions.
*
*	Last modify:	06/02/1999
*
*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
*/

/*------------------------ what, who, when and where ------------------------*/

#define         COPYRIGHT       "Emmanuel BERTIN (bertin@iap.fr)"
#define         INSTITUTE       "IAP"

/*----------------------------- Internal constants --------------------------*/

#define	BIG		1e31			/* A very big number */
#define	SMALL		1e-31			/* A very small number */
#define PI      	3.14159265

/*---------------------------- return messages ------------------------------*/

#define	RETURN_OK		0
#define	RETURN_ERROR		(-1)
#define	RETURN_FATAL_ERROR	(-2)

#ifndef	EXIT_SUCCESS
#define	EXIT_SUCCESS	0
#endif
#ifndef	EXIT_FAILURE
#define	EXIT_FAILURE	-1
#endif

#define	SWAP(a,b)	tempr=(a);(a)=(b);(b)=tempr

#define	OUTPUT		stderr
#define	RINT(x)		(int)(floor(x+0.5))

/*------------------------------- Other Macros -----------------------------*/



#define	QFREE(x)	{free(x); x = NULL;}

#define	QCALLOC(ptr, typ, nel) \
		{if (!(ptr = (typ *)calloc((size_t)(nel),sizeof(typ)))) \
	  error(EXIT_FAILURE, "Not enough memory for ", \
			#ptr " (" #nel " elements) !");;}

#define	QMALLOC(ptr, typ, nel) \
		{if (!(ptr = (typ *)malloc((size_t)(nel)*sizeof(typ)))) \
		  error(EXIT_FAILURE, "Not enough memory for ", \
			#ptr " (" #nel " elements) !");;}

#define	QMEMCPY(ptrin, ptrout, typ, nel) \
		{if (!(ptrout = (typ *)malloc((size_t)(nel)*sizeof(typ)))) \
		  error(EXIT_FAILURE, "Not enough memory for ", \
			#ptrout " (" #nel " elements) !"); \
		memcpy(ptrout, ptrin, (size_t)(nel)*sizeof(typ));}

#define	QREALLOC(ptr, typ, nel) \
		{if (!(ptr = (typ *)realloc(ptr, (size_t)(nel)*sizeof(typ)))) \
		  error(EXIT_FAILURE, "Not enough memory for ", \
			#ptr " (" #nel " elements) !");;}

#define	PADEXTRA(x) \
		((FBSIZE - (x%FBSIZE))% FBSIZE)

#define	QPRINTF		if (qflag) fprintf

#define	QFPRINTF(w,x)	{if (qflag) \
				fprintf(w, "\33[1M> %s\n\33[1A",x);;}

