#!/usr/local/bin/perl


package get_params_simple;


use Tk;
use Tk::Balloon;
 use Tk::NoteBook;


use strict;

use GUI::showCCD;
use PDL::PDLfuncs;


use vars qw/$t $outlist $fname @frames $hdlg/;
use vars qw/%rinput %routput /;


#------------------------------------------
# Phase 0: create the front end.
#------------------------------------------

sub mkform {

#$task=shift;
#$inlist=shift;
#my $routlist=shift;


my $conf=shift;

my $fname= $conf->{NAME};
#warn "$conf received ($fname)\n";

my $app = $main::top->Toplevel;
$app->title("Batch configuration ($fname)");

#$conf->LoadParams();

my $b = $app->Balloon;
 $app->OnDestroy(sub { $b->destroy; });

@frames=();

my $n=$app->NoteBook(-ipadx => 6, -ipady => 6);
my %page;

foreach my $field (@{$conf->{steps}}) {
 my $lcf=lc($field);
 my $p;
  my $pst='normal';

 if (exists $conf->{$lcf}{apply}{Value}) {
   if ($conf->{$lcf}{apply}{Value} eq 'no') {$pst='disabled'}
 }

   my $ucf=uc($field);

  if (exists $conf->{$field}{main}) {
# Here we display together different fields
             $p=$page{$conf->{$field}{main}};
             $p->Label(-text=>$ucf)->pack();
      }
   else {
      $p=$n->add($ucf, -label=>$ucf, -underline=>0, -state=>$pst);
      $page{$field}=$p;
   }

    my $r=0;         
    my $c=0;



   my $t  = $p->Table(-scrollbars => '', -fixedrows => 0, -rows => 20);
   $t->pack(-expand=> 1, -fill => 'both');

  my $e;
  my $f;

   #my $rfield=$main::params{$field};
      for my $opt ( @{$conf->{$field}{fields}}) {

          my $c=0;
	

	  my $option=$conf->{$field}{$opt};
	 
	 $f=$t->Label(-text => "$opt", -anchor => 'w');
            $t->put($r,$c++,$f);

#1. it is a section, so put a button 
            if ($opt eq 'sections') {	    
	       ${$e}=$t->Button(-text => "Define",	       
	       -command => (sub{
	          &showCCD::Show(CONF=>$conf, update=>'yes');		
		}) ); 	
            }
#2. Only "allowed" values are... allowed         
             elsif (exists($option->{Allowed})) {
	     
                 my @choices=@{$option->{Allowed}};
               
#                 if ($#choices >1) {
                  ${$e}=$t->BrowseEntry(-choices=>\@choices, -state=>'readonly', -width =>'20',
                                  -variable => \$option->{Value});
#            } else { 
#             foreach my $choice (@choices) {
#                 ${$e}=$t->Radiobutton(              
#                   -text     => $choice,
#                  -variable => \$option->{Value},
#                 -width =>5, 
#                 -relief   => 'flat',
#                -value    => $choice,
#                 );     
#               $t->put($r, $c++, ${$e} );               
#            }
#           }
          } else {
#3. it is a normal entry 
              ${$e} = $t->Entry(-width => '15', -relief => 'sunken',
                 -textvariable => \$option->{Value});
              # $frames[$r]->delete('0','end');
              # $frames[$r]->insert('0',$svals[$r-1]);
            }

            $t->put($r,$c++,${$e});
            #$frames[$r]=${$e};
            $b->attach($f, -msg => $option->{Help});

            if ($opt eq 'input') {
	      $rinput{$ucf} = ${$e}; 
	         
		  
                 my $mbutt=$t->Menubutton(-text=> "File", -relief=>'groove',
		    -menuitems=> [[ 'command'=>'Browse...',
		                    -command=> sub { 	
				    #   my $fn=$n->raised();
			               &main::fileDialog($t, $rinput{$ucf}, 'load', [qw/.lst .list/]);
			             }],
				 [ 'command'=>'Show infos',
		                    -command=> sub { 		         
			                my $list=$conf->getList(lc($ucf), 'input');
		                        showList($list);
			             }],
				 
				   ]); 
				    	  
		 $t->put($r, $c++, $mbutt);   
		  
	    } 
	   elsif ($opt eq 'output' || $opt eq 'wout') {
	      $routput{$ucf} = ${$e};	         
		
                 my $mbutt=$t->Menubutton(-text=> "File", -relief=>'groove', -padx=>5,
		    -menuitems=> [[ 'command'=>'Delete list',
		                    -command=> sub { 
				        my $list=$conf->getList(lc($ucf),'output');
 my $msg="The file $list (not the listed images) will be removed, are you sure ?";
  
  my $button = $t->messageBox('-icon' => 'warning', -type => 'OKCancel',
				-title => 'WARNING',
				-message => $msg);
  
  
  if ($button eq 'Ok') {
 	system ("rm $list") if (-e $list); 
	$msg="The file $list has been removed";
     $button = $t->messageBox('-icon' => 'warning', -type => 'OK',
				-title => 'WARNING',
				-message => $msg);
  }  				
			                }
				  ],
				  [ 'command'=>'Delete list and ! IMAGES !',
		                    -command=> sub { 		         
			                &InitStep($conf, lc($ucf));
			             }],
				 [ 'command'=>'Show Infos',
		                    -command=> sub { 		         
			                my $list=$conf->getList(lc($ucf), 'output');
		                        showList($list);
			             }]
				   ]); 
$mbutt->separator();
$mbutt->cascade(-label=>'Make Mosaic...');
my $menu_mos=$mbutt->menu->Menu; 

$menu_mos->command(-label=>'Keep background',
 -command=> sub {
 my $list=$conf->getList(lc($n->raised()), 'output');
		                       &PDLfuncs::domosaic($list, $conf, {LEVEL=>'no', UPDATE=>'no',
				              MKMOS=>'yes'})}
);

$menu_mos->command(-label=>'Subtract background',
 -command=> sub {
 my $list=$conf->getList(lc($n->raised()), 'output');
		                       &PDLfuncs::domosaic($list, $conf, {LEVEL=>'yes', UPDATE=>'no',
				              MKMOS=>'yes'})}
);


$mbutt->entryconfigure("Make Mosaic...", -menu=>$menu_mos);	
			   
		 $t->put($r, $c++, $mbutt);   		   
				   		
	    }  
	    

          $r++;
        }
 }
$n->pack(side => 'top', -pady => '2', -anchor => 'center', -fill=>'both', -expand=>'y' );


my $buttons = $app->Frame();
$buttons->pack(-side => 'bottom', -pady => '2', -anchor => 'center');
my $buttons_reset = $buttons->Button(-text => 'Default');
my $buttons_load = $buttons->Button(-text => 'Load');
my $buttons_save = $buttons->Button(-text => 'Save as');
my $buttons_savedef = $buttons->Button(-text => 'Save');
my $buttons_undo = $buttons->Button(-text => 'Undo changes');
my $buttons_close = $buttons->Button(-text => 'Quit');
#$buttons_go = $buttons->Button(-text => $go);
#$buttons_skip = $buttons->Button(-text => 'Next');

#If not interactive mode, windows are only used to show the parameters (read only)
#if ($main::redmode eq "interactive") {
    $buttons_reset->pack(-side => 'left', -padx => '2');
     $buttons_undo->pack(-side => 'left', -padx => '2');
    $buttons_load->pack(-side => 'left', -padx => '2');
    $buttons_save->pack(-side => 'left', -padx => '2');
    $buttons_savedef->pack(-side => 'left', -padx => '2');    
    $buttons_close->pack(-side => 'left', -padx => '2');
    #$buttons_go->pack(-side => 'left', -padx => '2');
    #$buttons_skip->pack(-side => 'left', -padx => '2');
#  }



# ------------------------------------------
# Phase 2: Help section
#------------------------------------------

$hdlg = $app->Dialog(-title => 'Help',-justify => 'left');

#------------------------------------------
# Phase 4: Miscellaneous other actions
#------------------------------------------

sub resetAction {
  my $conf=shift;
  my $cinst=$conf->Instrument();
  $conf->Instrument($cinst);
  #&main::LoadParams("$main::CONFIG");
}  #end clearAction

$buttons_reset->configure(-command => sub {resetAction($conf)} );

sub fileAction {
    my $fname=shift;
    my $oper=shift;
    my $conf=shift;
    &main::getFile($oper,\$fname,".par");
    if ($fname eq "") {return}
    #print "loading parameters from file $fname \n";
    if ($oper eq 'load') {   $conf->LoadParams($fname);
			    #my $cinst=$conf->Instrument(); #uhmmmmm
                        #    $conf->Instrument($cinst);
			    
			    }
    if ($oper eq 'save') {$conf->SaveParams($fname);}
} #end fileAction

$buttons_load->configure(-command => sub { &fileAction($fname,'load', $conf)} );
$buttons_save->configure(-command => sub{ &fileAction($fname,'save', $conf)});
$buttons_savedef->configure(-command => sub{
        $conf->SaveParams();
        &main::UpdateForm($conf)}
    );
$buttons_undo->configure(-command => sub { 
     $conf->LoadParams(); 
     &main::UpdateForm($conf)}  
 );
$buttons_close->configure(-command => (sub {undef $conf; $app->destroy}) );
#$buttons_skip->configure(-command => sub{$$routlist=$outlist;$app->destroy});



# We do this rather than simply $frame_1_e->focus to eliminate the Perl
# "single use" warning message.

#$frames[1]->focus;

 $app->waitWindow;

}


sub InitStep
# Purpose: delete all results for a given step from previous runs
{
my ($conf, $step)=@_;

my $list=$conf->getList($step,'output');
if (-e $list) {
  &main::DelList($list);
  $conf->Done($step, 0);
 }


# ==== in case of non science frames, 
# we should also delete temporary results 

if ($step ne 'science') {

$list=$conf->getList($step,'input');

my $tlist=&main::mktList($list);
if (-e $tlist) {
  &main::DelList($tlist);

  
  # === is there anything like sflt-<tlist> or sfrg-<tlist> ?
  my @s=split('/', $tlist);
  my $ks=$s[$#s];

  if ($step eq 'sflat') {
     $s[$#s]='sflt-'.$ks;
     $tlist=join('/', @s);
     if (-e $tlist) {
      &main::DelList($tlist);
   }
  }
  elsif ($step eq 'fringe') {
    $s[$#s]='sfrg-'.$ks;
    $tlist=join('/', @s);
    if (-e $tlist) {
      &main::DelList($tlist);
    }
  }

} 

 # $procStatus{$step}{DONE} = 'no'
}

} # end sub InitStep


sub showList
#display list and related infos
{
my $list=shift;

if (! -e $list) {return}

my $tl=$main::top->Toplevel;
$tl->title("$list");

my $bclose=$tl->Button(-text => 'Close')->pack(-side=>'bottom', -anchor=>'w');
$bclose->configure(-command => (sub {$tl->destroy}) );

my $checklist=$tl->Scrolled(qw/Text -width 80 -height 10 -setgrid 1
                              -scrollbars se/);
$checklist->pack(qw/-expand yes -fill y/);

$checklist->tag(qw/configure red -foreground red/);
$checklist->tag(qw/configure green -foreground darkgreen/);

open (ILIST, $list);
while (<ILIST>) {
    my @info=split(/\t/, $_);
    my $file=$info[0]; chomp($file);
    $file=~tr/ //d;
    my $s;
    my $col='green';
    if (-e $file) {
        my $mdays=-M $file;
	my $mabs=scalar localtime($^T-$mdays*86400);
	my $size=(-s $file)/1048576;  #the size in Mb
	$s=sprintf "\n   created %.2f days ago (%s), size: %.1f Mb\n", 
	       $mdays, $mabs,$size;
    } else {$s="\n   NOT FOUND !!!!\n"; $col='red'}
    $checklist->insert('end', $file); 
    $checklist->insert('end', $s, $col);   
 }
close (ILIST);

} #end sub showList




1; 
