#!/usr/bin/perl


use Cwd;
use File::Basename;
use Common::misc;
use Tk;
use Tk::HList;
use subs qw/show_dir/;
use vars qw/$FILEIMG $FOLDIMG $treetop @flist $lname $MLTOP/;
use vars qw/@fields @opers $lf %filters/;
use vars qw/$top/;

use GUI::FileDialog;
use Tools::MkTree;

use Tk::DirTree;
use Tk::Table;
use Tk::LabFrame;
use Tk::BrowseEntry;

use strict;
#no strict "refs";

&Init();
$top = MainWindow->new(-name => 'Prered', -title=>"Make Lists");

if ($main::DEBUG) {print "mklist.pl started !\n"}

displayDB();


sub displayDB
{

#my $dir=shift;
#my $dbfile=$dir."/".$SDFILE;

@fields=('object', 'DATE', 'Exp','Filter','Filedir', 'Extensions');
@opers=('contains','does not contain','is','is not', 'begins with','ends with',
'less than', 'greater than', '<=', '>=','');


my $dbfile=$main::SDFILE;

&main::getFile('load',\$dbfile, ".db");


if ($dbfile eq "") {return}

   @flist=();
   $lname="files.lst" if ($lname eq "");

my $mw = $main::top;

if (not Exists $MLTOP) {
 

   my $t=$top->Table(-scrollbars => 'se',-fixedrows => 1, -rows => 10,
   -columns=>10);
  $t->pack(-expand=> 1, -fill => 'both');

   
   # my $initlist = $mw->Button(-text => 'Initialize List');
 
   # my $lfiles = $mw->Button(-text => 'Save List');

    my $autolist = $mw->Button(-text => 'Make List');

     my $close=$mw->Button(-text => 'Close');
    
     $autolist->configure( -command   => sub{@flist=(); #initialize arrays
                                            AutoList($dbfile, $lname);  #Call Autolist
                                            } ); 
 
     $close->configure( -command   => sub {exit});
 
    #$initlist->pack( qw/-side left -padx 10 -pady 10/ ); 
    #$lfiles->pack( qw/-side left -padx 10 -pady 10/ ); 
    $autolist->pack( qw/-side left -padx 10 -pady 10/ ); 
    $close->pack( qw/-side left -padx 10 -pady 10/ ); 


my @opt = (-relief => 'groove');

my $r=0;
my $c=0;

if (not -e $dbfile) {
	$main::top->Dialog(
            -title  => 'File Not Found',
            -text   => "Can't load $dbfile",
            -bitmap => 'error',
        )->Show;
	return
}

open (DBFILE, $dbfile);


my $row;

while ($row= <DBFILE>)  {
    
   my @fields=split(/#/,$row);

 if ($r == 0) {
foreach my $name (@fields) {
print "--->$name\n";
  $t->put(0,$c++,$t->Label(-text=>$name,-anchor => 'e',-relief => 'raised'));
 }
$t->configure(-columns => $c) if ($c > $t->cget('-columns'));


} else {
 $c=0;
 foreach my $name (@fields) {
   $t->put($r,$c++,$t->Label(@opt,-text =>$name ,-anchor => 'e'));
  }
 }
 
$r++; 
 
} 
close (DBFILE);

$t->update;
$t->focus;

}

$mw->waitWindow;



} #end sub displayDB



sub displayTree {
#not used any more, it may be removed I think
my $i=shift;

    my $dirname = $$i;
 #   my $lname=shift;
 #   my @list=() ;   
 #   @flist=();

    if ($lname eq "") {$lname="files.lst"};

if (not Exists $MLTOP) {
 
    $MLTOP = $main::top->Toplevel;
   # $MLTOP->title('Create list of files');
     $MLTOP->title('Select database file'); 
    #my $lab=$MLTOP->Label(-text => 'Interactive mode: Double-click on a directory to include it and all its subdirectories, then click on \'Save List\'');
    #$lab->pack(qw/-side top/); 
    #my $lab=$MLTOP->Label(-text => 'Automatic mode: click on \'Automatic list\' ');
    #$lab->pack(qw/-side top/); 

      my $h = $MLTOP->Scrolled(qw\HList -separator / -selectmode extended -width 80
			   -height 30 -indent 35 -scrollbars se
			   -itemtype imagetext \
			   )->grid(qw/-sticky nsew/);
    $h->configure(-command => sub {
            my $size=$h->info('data', $_[0]);
	#    if ($size eq "DIR") {
        #       push(@list,$_[0]);
	#      print "Directory $_[0] added to list \n";
	#    }  
    });

my $menubar = $MLTOP->Menu(-type => 'menubar');
$MLTOP->configure(-menu => $menubar);
my $f=$menubar->cascade(-label => '~File', -tearoff => 0);
$f->command(-label => 'Exit', -command => sub{$MLTOP->destroy}, -underline => 0);

    $FILEIMG = $MLTOP->Bitmap(-file => Tk->findINC('file.xbm'));
    $FOLDIMG = $MLTOP->Bitmap(-file => Tk->findINC('folder.xbm'));
 


    my $olddir = cwd;
    chdir $dirname;
    show_dir ".", $dirname, $h;
    chdir $olddir;

    $h->pack(   qw/-expand yes -fill both -padx 10 -pady 10 -side top/ );

  }
 $MLTOP->waitWindow;

} #end displayTree

sub show_dir {
    my($entry_path, $text, $h) = @_;
    opendir H, $entry_path;
    my(@dirent) = grep ! /^\.\.?$/, sort(readdir H);
    closedir H;
    $h->add($entry_path,  -text => $text, -image => $FOLDIMG, -data => 'DIR');
    while ($_ = shift @dirent) {
	my $file = "$entry_path/$_";
	if (-d $file) {
	    show_dir $file, $_, $h;
	} # Take off comments if also files should be displayed
            else {
	    my $size = -s $file;
	    $h->add($file,  -text => $_, -image => $FILEIMG, -data => $size);
	}
    }
} # end show_dir

sub SaveList {

  my $fname=shift;
  

if ($#flist < 0) {print "no file selected ! \n"; return}
           
  #  if (not $fname) {$fname="files.lst"};
    &getFile('save',\$fname, ".lst");

#print "$fname\n";
    
    open (FILE, ">$fname");

# Store only files ending with .fits
    foreach my $i (@flist) {
    #convert e.g //u7/xxx to /u7/xxx 
              $i =~ tr\/\/\s;
              print FILE "$i\n";
       }
	
 
close (FILE);

#Now display the content of the file in a scrollable window, so user may check and in case modify its content

 my $listtop= $main::top->Toplevel;
 
my $t   = $listtop->Scrolled('Text')->pack(-expand => 1, -fill => 'both');
my $s   = $listtop->Button(-text => 'Save if modified', -command => sub{
                                                    open (FILE, ">$fname"); 
						    print FILE $t->get("0.0","end"); 
						    close FILE 
						      })->pack(qw/-side left -padx 10 -pady 10/);
my $b   = $listtop->Button(-text => 'Close window', -command => [destroy => $listtop])->pack(qw/-side right -padx 10 -pady 10/);

  my $cmd = "cat $fname";
 my $open_pid = open (TAIL, "$cmd|") || die "Can't open $cmd: $!";
 
 select (TAIL); $| = 1; 
 select (STDOUT); $| = 1; 

 $listtop->fileevent(\*TAIL, 'readable',
         sub {
              my $line = <TAIL>;     
              if (defined $line)
               {
                $t->insert('end',$line);
                $listtop->idletasks;
               }
              else
               {
                close(TAIL);
               }
         });

   
 } #end SaveList


sub AutoList {
   my ($dbfile, $lname)=@_;

my $nlist=sprintf("%d files found", $#flist+1);
my $rsearch=sprintf("%d entries found", 0);

 tie ( %filters, 'Tie::IxHash');


 my $mw = MainWindow->new();
 my $frame=$mw->Frame->pack(-side=>'bottom', -fill=>'both', -expand=>1);

   $lf = $mw->LabFrame(-label => "Package", -labelside => "acrosstop")->pack();

   &mkFilter();

   my $b=$frame->Button(-text => 'Search', -command=>(sub {
           my $nfound=searchDB($dbfile);
                 $rsearch=sprintf("%d entries found", $nfound);
                 $nlist=sprintf("%d files found", $#flist+1
                 );
      } ))->pack(qw/-side left -padx 10 -pady 10/ ) ;

    my $save=$frame->Button(-text => 'Save',  -command=>(sub {&SaveList($lname)})
    )->pack(qw/-side left -padx 10 -pady 10/ );

    my $close=$frame->Button(-text => 'Close',  -command=>(sub {$mw->destroy} )
    )->pack(qw/-side left -padx 10 -pady 10/ );

   my $result=$frame->Entry(-width=>20, -textvariable=>\$rsearch, -state=>'disabled')
     ->pack(qw/-side right -padx 10 -pady 10/ );

   my $files=$frame->Entry(-width=>20, -textvariable=>\$nlist, -state=>'disabled')
     ->pack(qw/-side right -padx 10 -pady 10/ );


      $mw->waitWindow;

}


 sub mkFilter{
  my ($efield, $eoper, $efilter, $b_and, $b_or, $b_more, $b_less);
   my $field=$fields[0];
   my $oper=$opers[0];


   my $comp=0;
   my $filter='';

    ${$efield}=$lf->BrowseEntry(-choices=>\@fields, -state=>'readonly', -width =>'20',
       -variable => \$field);

    $eoper=$lf->BrowseEntry(-choices=>\@opers, -state=>'normal', -width =>'20',
       -variable => \$oper);



    $efilter=$lf->Entry(-width => '15', -textvariable=>\$filter, -relief => 'sunken');

 $b_and=$lf->Radiobutton(
     -text     => "AND",
     -variable => \$comp,
     -relief   => 'flat',
     -value    => 1,
 );

  $b_or=$lf->Radiobutton(
     -text     => "OR",
     -variable => \$comp,
     -relief   => 'flat',
     -value    => 0,
 );


   $b_more=$lf->Button(-text => 'More', -command=>(sub {
           &mkFilter();
        } )) ;

   $b_less=$lf->Button(-text => 'Fewer', -command=>(

            sub {
            my @keys=keys %filters;
            if ($#keys >0 ) {
               ${$efield}->gridForget($eoper, $efilter,  $b_and, $b_or, $b_more, $b_less);
               delete $filters{$efield} }
            } )) ;


 ${$efield}->grid($eoper, $efilter, $b_and, $b_or, $b_more, $b_less);

   my $i=0;
   $filters{$efield}[$i++]= \$field ;
   $filters{$efield}[$i++]= \$oper ;
   $filters{$efield}[$i++] = \$filter ;
   $filters{$efield}[$i++] = \$comp ;

}

sub troper
 {
   my ($op1, $op2, $oper)=@_;
    my $res;

    if ($oper eq 'contains') {
       $res="\'$op1\' =~ /$op2/";
    }
   elsif ($oper eq 'does not contain') {
       $res="\'$op1\' !~ /$op2/";
    }
   elsif ($oper eq 'is') {
       $res="\'$op1\' eq \'$op2\'";
    }
    elsif ($oper eq 'is not') {
       $res="\'$op1\' ne \'$op2\'";
    }
    elsif ($oper eq 'begins with') {
       $res="\'$op1\' =~ /^$op2/";
    }
   elsif ($oper eq 'ends with') {
       $res="\'$op1\' =~ /$op2\$/";
    }
   elsif ($oper eq 'less than') {
       $res="\'$op1\' < /$op2\$/";
    } 
   elsif ($oper eq 'greater than') {
       $res="\'$op1\' > /$op2\$/";
    } 
   elsif ($oper eq '<=') {
       $res="\'$op1\' <= /$op2\$/";
    } 
   elsif ($oper eq '>=') {
       $res="\'$op1\' >= /$op2\$/";
    }   
   else {   #use whatever the user wants to use.... ;)
       $res="$op1 $oper $op2";
    }


    return $res;
 }

 sub searchDB
 {

 my $dbfile=shift;

 my @names=();
 @flist=();
 my @roots=();

 (my $dbn, my $ddir) = fileparse($dbfile);


  open (DB, "$dbfile");
  while (<DB>) {
   my $row=$_;
    if ($#names == -1) {
     @names=split(/\t/,$row);
     next;
    }

   my @values=split(/\t/,$row);

   my $nentry=0;
   my $eval='';
   my $nfilter=0;

#Read the filters and loop on them
   my @keys=keys %filters;
   foreach my $entry (@keys) {

      my $i=0;

         my $field=${$filters{$entry}[$i++]};

         my $column=0;
         my $found=0;

       #Find the right column
         foreach my $name (@names) {
             if ($names[$column] =~/$field/i) {$found=1; last}
             $column++;
          }
         next if ($found!=1);
         my $value=lc($values[$column]);

         $value=~ tr/ //d;  #get rid of spaces

         if ($field =~ /exp/i) {$value =~ tr/[a-z]//d} #get rid of all letters

             my $oper=${$filters{$entry}[$i++]};

            my $filter=${$filters{$entry}[$i++]};
            next if ($filter eq '');


            my $comb=${$filters{$entry}[$i++]};

            my $string = troper($value, lc($filter) , $oper);

            my $log=' || ';
            if ($comb == 1) {$log=' && '}

           if ($nfilter !=0 ) {$string=$log.$string}
           $eval=$eval.$string;
           $nfilter++;
   }
   my $res=eval($eval);

  if ($res) {
       push (@roots,$values[3] ) ;
if ($main::DEBUG) {print "============= $row\n  $eval\n >>>> result=$res ! <<<< \n"}
   }
  }
  close (DB);

  if ($#roots >-1) {
     #Now look for TRUE files
    foreach my $root (@roots) {
       $root=~ tr/ //d; 
       my $dir=$main::DATADIR.$root;
if ($main::DEBUG) {  print "Reading files in $dir\n"; }    
       my @files= glob($dir."/*[0-9].fits");
       #@files=grep(/$ccd/i, @files);
       push(@flist,@files);
if ($main::DEBUG) {print "        found $#files files\n";}
     }
if ($main::DEBUG) {print "found $#flist files\n"}
  }

return ($#roots+1);

 }


1;
