package CFHT;

use Instr::Header;
@ISA = ("Header");

sub init_head  {
my $self=shift;

#$self->{LAT}=19.8267;

$self->{_table} =
{
 ORIGIN => 'ORIGIN',
 DETECTOR  => 'DETECTOR',
 RUNID=> 'RUNID',
 RA => 'CRVAL1',
 DEC => 'CRVAL2',
 OBSTYPE => 'OBSTYPE',
 EXPTIME => 'EXPTIME',
 FILTER => 'FILTER',
 DATE => 'DATE',
 LOCTIME => '',   #to be compared with HSTTIME
 'LST-OBS' => 'LST-OBS', 
 OBJECT  => 'OBJECT',
 IMAGEID  => 'IMAGEID',
 FILENAME => 'FILENAME'
 };
}

sub Translate
{
 my $self=shift;
 my $input=shift;
 
 
 $self->getVals($input);

# ================================================================
#   Last but not least, 'fix' the values to a standard convention
# ================================================================


my $locdate='';

 while  (my ($key, $value) = each %{$self}) {
     next if (ref($value) eq 'HASH');
     $value=~tr/\'| //d if ($value);
    if  ($key eq 'RA') {
        $value=$self->sexRA($value);

     }
     elsif  ($key eq 'DEC') {

        $value=$self->sexDEC($value);

     }
#     elsif  ($key eq 'LOCTIME') {
#        $_=$value;
#        my @loctime=/(\d{2,2}):(\d{2,2}):(\d{2,2})/;
#	$value=join (':', @loctime);
#     }
     elsif  ($key eq 'LOCTIME') {   #store the date in locdate   
         my $date=$self->{DATE};
         $date=~tr/\'| //d; 
        my ($utdate, $HHMMSS)=split('T', $date,2);
        ($locdate, $value)=$self->UT2Local($utdate, $HHMMSS, 10); 

     }

     $value =~ s/[^a-zA-Z0-9+-:.]+// ; #remove all non ascii characters
     $self->{$key}=$value;

  }



if (exists $self->{LOCTIME}) {
  $self->{LOCDATE}=$locdate;
  $self->set_locdate;
}

#if (exists $self->{RA} && exists $self->{DEC} && 
# exists $self->{'LST-OBS'} && exists $self->{LAT}) {
#  $self->setAirMass;
#}
 
} #end sub Translate

sub HowMany
#return the number of extensions 
{
my $self=shift;
my $name=shift;
my @nfound=glob("[0-9].fits");
my $nfound=$#nfound+1;   

return $nfound;
}

 1;
