package cfh12k;

use Instr::CFHT;
@ISA = ("CFHT");

sub init_props {
 my $self=shift;

$self->{_properties} =
{
   MINCCD=> 0,
   NCCDX=> 6,
   NCCDY => 2,
   NUMCCD=> 12,
   data => {        
     section=>[]
   },
   trim => {
     section =>[]
   },
   overscan => {
     section=>[],
     order => 1
   },  
   FITS_TYPE => 'SIMPLE', 
    CCDid => [],
     CCDpos => [],
};

#set sections


$self->Section(step=>'data',c1=>1, c2=>2080, r1=>1, r2=>4100);
my $nccd=$self->{_properties}{NUMCCD};

#set overscan and trim sections
my @ids=();
foreach my $i (0..$nccd-1) {
    $self->Section(step=>'overscan', ccd=>$i,c1=>2069, c2=>2079, r1=>100, r2=>4000);  
    $self->Section(step=>'trim', ccd=>$i,c1=>6, c2=>2045, r1=>5, r2=>4096);
    push @ids, $i;
  }

#set the CCDid  
 $self->{_properties}{CCDid}=\@ids;

#set the geometrical position
 $self->{_properties}{CCDpos}=\@ids;


} #end sub init

 1;
