#!/usr/local/bin/perl

#use English;

package get_params_iraf;


use Tk;
use Tk::Dialog;
use FileDialog;
use Iraf::help;


#------------------------------------------
# Phase 0: create the front end.
#------------------------------------------

sub mkform {

$task=shift;
$inlist=shift;
my $routlist=shift;

my $ret=1;

#The usage of $outlist depend on the calling task
# IF ccdproc, then it may contain the list of ME files, if they are created (OUTPUT to main procedure);
# otherwise, it contains the name of the FINAL list (INPUT from main procedure)
$outlist=$$routlist;

$proc="";

my $app = $main::top->Toplevel;
$app->title('IRAF interface: '.$task);

# Use a scrollable table (useful for task with many parameters)
my $t  = $app->Table(-scrollbars => 'e',-fixedrows => 1, -rows => 20);
$t->pack(-expand=> 1, -fill => 'both');


my $c=0;

$t->put(0,$c++,$t->Label(-text=>"Entry",-anchor=>'w'),-relief => 'raised');
$t->put(0,$c++,$t->Label(-text=>"Value",-anchor=>'w'),-relief => 'raised');

$t->configure(-columns => $c) if ($c > $t->cget('-columns'));



my $go="Run ";

#/////////////////////////////////////////////////////////////////////
# Here $task is the task of the procedure, that is what it should do
#      $proc is the procedure which is actually called 
#////////////////////////////////////////////////////////////////////

if ($task =~ /combine$/) {
  @names=("","input",
  "output",  "combine", "reject" , "delete" , "scale"  ,"statsec","nlow"  , "nhigh" ,  "nkeep" ,  "mclip" ,  "lsigma",  "hsigma",  "rdnoise", "gain"   , "snoise" , "pclip"  , "blank");
 # if ($task eq 'zerocombine') {$mainfile="./zerocombine.cl"; }
 # elsif ($task eq 'darkcombine') {$mainfile="./darkcombine.cl"; }
 # elsif ($task eq 'flatcombine') {$mainfile="./flatcombine.cl";}
  $proc=$task;

}
elsif ($task =~ /ccdproc$/) {
#CCDPROC parameters in MSCRED 
@names=("","images", "noproc","overscan","trim",
"fixpix","zerocor","darkcor","flatcor",
"biassec","trimsec","fixfile","zero","dark",
"flat","minreplace",
"function","order","sample","naverage","niterate","low_reject","high_reject","grow",
"plotfile");
#$mainfile="./ccdproc.cl";
 $proc="ccdproc";
}

#this is the "default" parameter file for each task (bias, dark, flat and process)
  $mainfile=$task.'.cl';

&iraf_help::defHelp($proc);
$nfields=scalar(@names);

#IRAF allows to use any name for the script, but this may be better to prepare the automatic mode
 my $defscript=$mainfile;

 $go=$go.uc($proc);

@frames=();
#$nfields=scalar(@names);

$fname=$mainfile;

my $r=1;

foreach my $i (1..$nfields-1) {

    # Use symbolic/soft references to create the widget names at object time.
    
     my $c=0;

    ${$e} = $t->Entry(-width => '50', -relief => 'sunken');

    $frames[$r]=${$e};

    $t->put($r,$c++,$t->Label(-text => "$names[$i]", -anchor => 'e'));
    $t->put($r,$c++,${$e});

    $ref_to_name{$e} = ${$e};	# map Entry widget to its Perl/Tk reference

    $r++;

}


my $buttons = $app->Frame();
$buttons->pack(-side => 'bottom', -pady => '2', -anchor => 'center');
$buttons_clear = $buttons->Button(-text => 'Clear');
$buttons_load = $buttons->Button(-text => 'Load');
$buttons_save = $buttons->Button(-text => 'Save as');
$buttons_savedef = $buttons->Button(-text => 'Save def.');
$buttons_go = $buttons->Button(-text => $go);
$buttons_skip = $buttons->Button(-text => 'Next');

#If not interactive mode, windows are only used to show the parameters (read only)
if ($main::redmode eq "interactive") {
   $buttons_clear->pack(-side => 'left', -padx => '2');
   $buttons_load->pack(-side => 'left', -padx => '2');
   $buttons_save->pack(-side => 'left', -padx => '2');
   $buttons_savedef->pack(-side => 'left', -padx => '2');
   $buttons_go->pack(-side => 'left', -padx => '2');
   $buttons_skip->pack(-side => 'left', -padx => '2');
}

#------------------------------------------
# Phase 1: Add menus, dialog boxes
#------------------------------------------


$menu = $app->Frame(-relief => 'raised', -borderwidth => '1');
$menu->pack(-before => $t, side => 'top', -fill => 'x');

$menu_file = $menu->Menubutton(-text => 'File', -underline => 0);

$menu_file->command(-label => 'Exit', -command => sub{$ret=0;$app->destroy}, -underline => 0);
$menu_file->pack(-side => 'left');

# ------------------------------------------
# Phase 2: Help section
#------------------------------------------

$hdlg = $app->Dialog(-title => 'Help',-justify => 'left');


$app->bind('<Any-F12>' => sub {
    my $w = shift;
    my $e = $w->XEvent;
    &msgHelp($w->containing($e->X, $e->Y), $e->X, $e->Y);
});

#------------------------------------------
# Phase 4: Miscellaneous other actions
#------------------------------------------

sub clearAction {
    foreach my $i (1..$nfields-1) {
	$frames[$i]->delete('0', 'end');
    }
} #end clearAction

$buttons_clear->configure(-command => \&clearAction);

sub goAction {

  my $ret=1;

  if (-e "doit.cl") {system ("rm doit.cl") }

if ($task =~ /ccdproc$/) {
        #Create a copy of the files and check the header
               if (&copyFITS("mkfits.cl")) {
                  system ("cp mkfits.cl doit.cl") ;
               }
	     }

SaveParams($mainfile, "go"); #save current script file and check for list

if ($task =~ /combine$/) {
     SaveParams($mainfile, "go"); #save current script file and check for list
       my $o=$outlist;
       if ($o !~ /@/ && $o !~ /\.fits/) {$o=$o."*.fits"};
#         if (-e $o) {

             my $dcmd="del (\"$o\", verify=no)";
              open (FILE, ">>doit.cl");
                   print FILE "$dcmd\n";
              close (FILE);
              
#          }
     }


     if ($inlist eq "") {$ret=0 ;print "$task was not executed\n";return $ret}


# Append scripts in order to avoid to call Iraf twice
     system ("cat $mainfile >> doit.cl") ;

      if ($main::redmode ne "listonly") {
               my $elapsed=time;
               CallIRAF("doit.cl");
               $elapsed=time-$elapsed;
               print "IRAF completed $task after $elapsed s !!!\n";
       }; #ok, start IRAF



return $ret;

} #end goAction


$buttons_go->configure(-command => \&goAction);

sub fileAction {
    my $oper=shift;
    &main::getFile($oper,\$fname,".cl");
    #print "loading parameters from file $fname \n";
    if ($oper eq 'load') {LoadParams($fname, ".cl");}
    if ($oper eq 'save') {SaveParams($fname, ".cl");}
} #end fileAction

$buttons_load->configure(-command => sub { &fileAction('load')} );

$buttons_save->configure(-command => sub{ &fileAction('save')});

#This is needed to prepare the scripts for the automatic mode,
# when the scripts are created using the default names
$buttons_savedef->configure(-command => sub{&SaveParams($defscript)});

$buttons_skip->configure(-command => sub{$app->destroy});



#----------------------------------------------------
# Phase 5: Accelerators, mnemonics, command-line info
#----------------------------------------------------

$menu_file_m = $menu_file->cget(-menu);
$menu_file_m->entryconfigure(2, -accelerator => 'Ctrl+Q');
$app->bind('<Control-q>' => sub {exit});


LoadParams($mainfile);

# We do this rather than simply $frame_1_e->focus to eliminate the Perl
# "single use" warning message.

$frames[1]->focus;

#automatic mode 
if ($main::redmode eq "auto" || $main::redmode eq "listonly")
 { 
    if (not -e $mainfile) {print "Auto mode failed because $mainfile is missing\n"} else  
       {$ret=&goAction;
        if ($main::redmode eq "auto") {$app->withdraw};
       }
   } else {$app->waitWindow;}

$$routlist=$outlist;

return $ret;

}

sub LoadParams
  {
my $file = shift;

&clearAction; #clear the window

if ( not open (FILE, $file)) {
	$main::top->Dialog(
            -title  => 'File Not Found',
            -text   => "Can't load $file",
            -bitmap => 'error',
        )->Show;
	return
     }
while (<FILE>) {
chomp($_);

         @vals =split("=",$_,2);
	 @string=split('\.',$vals[0],2);
	 $field=$string[1];
         $field =~ tr/ //d;       
	 foreach my $i (1..$nfields-1) {
	     if ($field eq $names[$i]) {
                 my $val=$vals[1];
#--------------------------------------------
#HERE I PUT SOME CASES WHERE VALUES LOADED FROM FILE ARE MODIFIED BY THE PROGRAM
# Get rid of " and spaces 
                 $val =~ tr/"//d;
                 $val =~ tr/ //d;

#if making zerocombine, then zero, dark and flat must be set to NO
               if ($task eq 'zeroccdproc') {
                    if ($field eq 'zerocor') {$val='no'} 
                    elsif ($field eq 'darkcor') {$val='no'} 
                    elsif ($field eq 'flatcor') {$val='no'} 
                   } 

#if making darkcombine, then dark and flat must be set to NO
               elsif ($task eq 'darkccdproc') {
                    if ($field eq 'darkcor') {$val='no'} 
                    elsif ($field eq 'flatcor') {$val='no'} 
                   } 

#if making flatcombine, then flat must be set to NO
               elsif ($task eq 'flatccdproc') {
                    if ($field eq 'flatcor') {$val='no'} }
 
#if $inlist was given in the arguments and is not blank (if blank use value already given in file),
# then use that value (use the fact that in IRAF lists are given as the first argument)
               if ($i==1 && $inlist ne "") {$val=$inlist}
#same for output
               if ($outlist ne "" && $task =~ /combine$/ && $i==2) {$val=$outlist}	
#--------------------------------------------
#ok, display values

	         $frames[$i]->delete('0', 'end');
                 $frames[$i]->insert('0', $val);
		}
	}
   }
		 
 close (FILE);

#The first entry in the list contains the list of images: store it into the global $inlist variable
$inlist=$frames[1]->get;

#This is now the new current file
$mainfile=$file;

  } #end LoadParams


sub SaveParams
  {
my $file = shift;
my $action=shift; 

 open (FILE, ">$file");

# In IRAF, the input files must be given as an argument of the task
# when calling it, otherwise it will ask for it.
# So,  print it in the form ....

foreach my $i (1..$nfields-1) {
#read value from entry; 
       my $value=$frames[$i]->get;
#get field from the @names array  
        my $field=$names[$i];
#The first field is the list of images: copy it into the global $inlist variable
#       if ($i == 1) {$inlist=$value};

#//////////////////////////////////////////////////////////////////////////////
# This section manipulates what is sent to the IRAF script

#(1) "New" parameters added in the form
  if ($task =~ /ccdproc$/ && $field eq "plotfile") {
           print FILE "ccdred.$field = \"$value\" \n";
              if ($action eq "go" && -e $value) {system ("rm $value")}
           next; #skips to next value
    }
  elsif ($task =~ /combine$/ && $field eq "output") {$outlist=$value}

              

# (2) IRAF wants strings, sections and * between quotes, but keep out booleans
	if ( ($value =~ /[a-z]|[A-Z]/ && $value !~ /\b(Y|y|yes|YES|no|NO|n|N)\b/) || ($value =~ /\*/) ||($value =~ /\[|\]/) || ($value eq "")) {
                       print FILE "$proc.$names[$i] = \"$value\" \n"
               } 
	        else {print FILE "$proc.$names[$i] = $value\n"};
 

#//////////////////////////////////////////////////////////////////////////////
 } #end of loop on names

#//////////////////////////////////////////////////////////////////////////////
# This section writes in the IRAF script some parameters which are not displayed in the form
  #write some parameters not given in the interface
      if ($task =~ /ccdproc$/) {
            print FILE "$proc.ccdtype = \"\"\n"; #do not select ccd types  
            print FILE "$proc.illumcor = no\n"; #do not apply illumination correction
            print FILE "$proc.fringecor = no\n"; #do not apply fringe correction
            print FILE "$proc.readcor = no\n"; #do not convert zero image to readout correction
            print FILE "$proc.scancor = no\n"; #do not convert flat image to scan correction
            print FILE "$proc.interactive = no\n"; #IRAF can't be used in interactive mode from external calls
      }
      elsif ($task =~ /combine$/) {
            print FILE "$proc.ccdtype = \"\"\n"; #Do not use ccdtype in combination
            print FILE "$proc.process = no\n"; #This should have already been done by CCDPROC
#            print FILE "$proc.clobber = yes\n"; #Overwrite image if exists (not implemented ?)                                    
        } 
#\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\      

#... and then give the entry number 1 as an argument of the task
my $value=$frames[1]->get;
if ($task =~ /combine$/) {
        print FILE "$proc(\"$value\", output=\"$outlist\")\n"
    } 
elsif ($task =~ /ccdproc$/) {print FILE "$proc(\"$value\")\n";}

close (FILE);

#check that the input list really exists
if ($main::redmode eq "interactive" && $action eq "go" ) {
      # in order to check if the file exists, we must get rid of the @
                my $flist=$inlist;
                $flist =~ s/\@//;
	        if (not -e $flist) {
	       		$main::top->Dialog(
                            -title  => 'ERROR !!!',
                            -text   => "Can't find the input list ($flist),\n please make it",
                            -bitmap => 'error',
                        )->Show;
			&main::mklistAction;
		      }
            }



#This is now the new current script file (user may have changed the default name)
$mainfile=$file;



} # end SaveParams



sub copyFITS {

  use File::Copy;

my $fscript=shift;
$inlist=$frames[1]->get;

my $flist=$inlist;

# If nothing done, we simply get $outlist=$inlist
$outlist=$inlist;

# in the IRAF environment , @ just means that it is a list (it is not included in the filename)
$flist=~s/\@//;

#create an out-xxx list from a xxx list
my $nopath=$flist;
my @string=reverse(split(/\//,$nopath));
$nopath=$string[0];
$nopath="out-".$nopath;
my $oflist=$flist;        
$oflist=~ s/$string[0]/$nopath/;

#read the list of files
open (FILE, $flist);
   my @all=<FILE>;
close (FILE);

#this variable will contain the 'root' names of the FITS files
# the file name is assumed to be in the format e.g. <path>456273d01.fits

my @roots=();

# this variable will contain the number of CCDs
$nccd=0;

for my $name (@all) {
chomp($name);

# take off the .fits extension
$name =~ s/\.fits$//;

$_=$name;

# this separates the root from the sequential CCD number
@string=/(.*\d+[a-z]+?)(\d+)$/;

if ($string[0] && $string[1]) {
#updates the number of CCDs
     if ($string[1] > $nccd) {$nccd=$string[1]};
#store the roots ONLY if the output fits does not exist
     push (@roots,$string[0]);
   }
}

#if (scalar(@roots) == 0) {
# All files in the list are already packed, so do nothing !
#   return 0;
#}

#should not be necessary to sort, but one never knows.......
#@roots=sort @roots;

$nccd=$nccd+1;

#check which format should be taken for numbering
my $dflg=0;
my $dig='';
if ($nccd >= 10) {$dflg=1}

if ($dflg) {$dig='0'}

#Everything will be sent to the script and then sent to IRAF, which will do the job
#
open (SFILE, "> $fscript");
#print SFILE "print (\"Copying the FITS file\") \n";

#a new list of files to be processed is created
open (LFILE, "> $oflist");



for (my $i=0; $i < scalar(@roots); $i+=$nccd) {

 $dig='0';
 my $newds="";
 
 foreach my $j (0..$nccd-1) {
       my $n=$j+$i;
       
       if ($j==0) {
         # check DATASEC in header of the first file, unflips it and store the result in $newds 
           &getdatasec($roots[$n].$dig.'0.fits', \$newds);
         }

       if ($dflg && $j > 9) {$dig=''}

       my $from=$roots[$n].$dig.$j.'.fits';
       my $to =$roots[$n].$dig.$j.'O.fits'; 
       if ($main::redmode ne "listonly") { copy ($from,$to) } 

         print LFILE  "$to\n";


 }

#This will fix the  DATASEC field in the header, since otherwise CCDPROC will complain 
# in case of flipped sections
print SFILE " print (\" WARNING: DATASEC field is modified in the output FITS !!\") \n";
#print SFILE " ccdhedit (\"$roots[$i]\", \"ccdsec\", \"\") \n";
#print SFILE " ccdhedit (\"$roots[$i]\", \"datasec\", \"\") \n";
#print SFILE " ccdhedit (\"$roots[$i]*O*\", \"DATASEC\", \"$newds\") \n";
print SFILE "hedit (\"$roots[$i]*O*\", \"DATASEC\", \"$newds\", show=no, update=yes ) \n";

}


close (SFILE);
close (LFILE);

#Ok, store the new list in the global variable $inlist, but put back the @
#Also, put the new name into $outlist, which will be read by the main procedure
#Do not perform this step in the "listonly" mode (we do not want to change 
# anything in the parameter script, in this case) 
if ($main::redmode ne "listonly") {
   
   $inlist='@'.$oflist;
   $outlist=$inlist;
  
   $frames[1]->delete('0',end);
   $frames[1]->insert('0',$inlist);
} else {print "$inlist will be changed to \@$oflist\n"}


return 1;

} #end sub copyFITS



sub CallIRAF
{
  my $script=shift;
  if (not -e "./login.cl")  {
      my $button = $main::top->messageBox('-icon' => 'Warning' , -type => 'YesNo',
         -title => 'Message',
         -message => "No login.cl file in the current directory,\n may I create it ?");
               {if ($button eq "No") {
               $main::top->Dialog(
                  -title  => 'File Not Found',
                  -text   => "I am sorry, I NEED the file 'login.cl' !",
                  -bitmap => 'error',
               )->Show;
	       return
              }
             else {print "Ehm, not yet done..... :I  \n"}; return}
     }

  open (SFILE, ">> $script");

  print SFILE "logout\n";

  close (SFILE);

  #my $cmd="cl < $script";
  my  $cmd="cl < $script >> $main::logfile"; # This may be used to create a logfile

  system ($cmd);


} #end sub CallIRAF

sub msgHelp
{

     my($topic, $x, $y) = @_;
    if ($topic eq '') {return;};

my $idx=0;

   foreach my $i (1..$nfields-1) {if ($topic eq $frames[$i]) {$idx=$i; last}}

if ($idx >0 && defined $iraf_help::helpTopics[$idx]) {
   $msg=$iraf_help::helpTopics[$idx]} else
   {$msg="Sorry, no help !"}

#    while (defined $helpCmds{$topic}) {
#	$topic = $helpCmds{$topic};
#    }
#    for $widget (keys %ref_to_name) {
#	$topic = $widget if $topic eq $ref_to_name{$widget};
#    }
#    if (defined $helpTopics{$topic}) {
#	$msg  = $helpTopics{$topic};
#    } else {
#	$msg = 'Sorry, but no help is available for this topic';
#    }
    $hdlg->Subwidget('message')->configure(
        -text => "Information on $proc:$names[$idx]\n\n$msg");
    $hdlg->Show;
} #end sub Help

sub getdatasec
{
my $input=shift;
my $newsec=shift;

my $fix80=80;
open (CCD, $input);
my $header=<CCD>; 
my $length_header=length($header);
my $offset=0;

while ($offset < $length_header)
   {$_=substr($header,$offset,$fix80);
   if (/DATASEC =/ ) {
   my @string=split(/'/,$_,3);
   my $s=$string[1];
   $s=~tr/[\[\]]//d;
   $_=$s;
   my @n=/(\d{1,4}):(\d{1,4}),(\d{1,4}):(\d{1,4})/;
   if ($n[1] < $n[0]) {$t=$n[0]; $n[0]=$n[1]; $n[1]=$t}
   if ($n[2] > $n[3]) {$t=$n[2]; $n[2]=$n[3]; $n[3]=$t}

   $$newsec="[$n[0]:$n[1],$n[2]:$n[3]]";
last;

 }
 $offset+=$fix80;

}
close(CCD);

} #end getdatasec
  
1;

