use PDL;
use CFITSIO qw( :longnames :constants);
use PGPLOT;
use  PDL::Graphics::PGPLOT;

use Common::fitsio;
use Tie::IxHash;

my $plot = PDL::Graphics::PGPLOT::Window->new({Device=>"fringe.ps/CPS"});
$plot->env(1,4000,-2.5e5, 2.5e5);
#$plot->env(1,4000,5.2e6, 5.4e6);
my $list='/i4/radovich/link/Processed/kfrg.lst';

open (FILE, $list);

while (<FILE>) {
  chomp($_);
  my $file=$_;
  print "reading $file\n";
  next if (! -e $file);
  my %h;
  tie (%h, 'Tie::IxHash');  
  %h=&fitsio::rhead($file);
  my ($image, $ret)=&fitsio::rfits($file);
  my $kim=sumover($image);
  $kim-=average($kim);
  print $kim->info;

  my $output=$file;
  $output =~ s/\.fits$/_1d.fits/;
  print "   $file -> $output\n";
  &fitsio::wfits($kim, $output,  \%h);
  if ($output =~ /wfi5/) {$col='RED'}
  elsif ($output =~ /wfi6/) {$col='YELLOW'}
  else {$col='GREEN'}
  $plot->line($kim, {COLOR=>$col}); 
}

close (FILE);

$plot->close;
