use PDL;
use CFITSIO qw( :longnames :constants);
use PGPLOT;
use  PDL::Graphics::PGPLOT;

use Common::fitsio;
use Tie::IxHash;

use Mylib::Pfit;
use Mylib::Robust;

use strict;

my $chip="06";

#my $nimsub="/samplix3/radovich/Pretest/Apr00II/Processed/Temp/531161o.CFH12K.I.sfrg.#$chip.fits";

#my $nfringe="/samplix4/radovich//Apr00-2/Processed/Store/Fringe.CFH12K.I.#$chip.fits";

my $nimsub="/mapix1/radovich/PRERED/531161o.CFH12K.I.sfrg.#$chip.fits";

my $nfringe="/mapix1/radovich/PRERED/Fringe.CFH12K.I.#$chip.fits";

my $nobj="/mapix1/radovich/PRERED/objects.fits";

my ($imsub, $ret)=&fitsio::rfits($nimsub);
my ($fringe, $ret)=&fitsio::rfits($nfringe);
my ($objs, $ret)=&fitsio::rfits($nobj);

 my $im1da=$imsub->clump(-1);
 my $fr1da=$fringe->clump(-1);
  my $obj1da=$objs->clump(-1);

 my $nz=which($im1da !=0 & $im1da>-10000 & $obj1da==0);
print $nz->nelem, " points removed !\n";
my ($im1d, $fr1d);

if ($nz->isempty) {
  $im1d=$im1da;
  $fr1d=$fr1da;
} else {
print $nz->nelem,"/",$im1da->nelem, " points removed !\n";
  $im1d=$im1da->index($nz);
  $fr1d=$fr1da->index($nz);
}


my @ss=(); my $sig=0; my @cc=();
my @cc=(8.6935223798903, 0.83335502441863);


my $wdw=5;

my $xs=&Mylib::Robust::MedBlock($fr1d, $wdw);
my $ys=&Mylib::Robust::MedBlock($im1d, $wdw);
print "Fit - start\n";
my $yfit;
#@cc=&Mylib::Robust::Robust_LinFit($xs, $ys, \$sig, \@ss);
#my $yfit=$cc[1]*$fringe;
@cc=&Mylib::Robust::Robust_PolyFit($xs, $ys, 2, \$yfit);
#$im1d-=$yfit;
print "Fit - end\n";
print "-> $#cc: $cc[0] $cc[1] $cc[2] $cc[3]\n";

#my %him; 
#tie (%him, 'Tie::IxHash');  
#%him=&fitsio::rhead($nimsub);
#my $ret=&fitsio::wfits($imsub, 'simage.fits',\%him);
#print "$ret\n" if ($ret);


my $psfile="franal.ps";

my $plot = PDL::Graphics::PGPLOT::Window->new({Device=>"$psfile/CPS", NYPanel=>1, CharSize=>1.6});

#my $ximsub1d=$im1d;
#my $xfringe1d=$fr1d;


my $ximsub1d=$ys;
my $xfringe1d=$xs;

#my $xf=float[min($xfringe1d), max($xfringe1d)];
my $xf=(max($xfringe1d)-min($xfringe1d))/1000*sequence(1000) + min($xfringe1d);
my $yf=$cc[-1];
for (my $i=$#cc-1; $i>=0; $i--) {
$yf=$yf*$xf+$cc[$i]
}


#$plot->env(minmax($xfringe1d), minmax($xfringe1d));
$plot->env(-400, 400, -400, 400);
$plot->label_axes('Fringe', 'Image', '', {COLOR=>'BLACK'});

$plot->line ($xf, $yf, {COLOR=>'RED'});
$plot->points($xfringe1d, $ximsub1d, {SYMBOL=>'DOT', COLOR=>'BLACK'}); 


$plot->close;

