
#use Common::misc;
use Sex::SEXconf;

use strict;


sub doSEx {

my ($inlist, $step, $routlist) = @_;
my $routlist2="";
$routlist2=pop if ($#_==3);

my $ret=0;


&InitSEx();

#Make the configuration file 
my ($chimtype, $options)=mkConfig($step);

#Create the temporary output list
# for fringe and sflat the input is a list
# for all other cases, it is a single image !

my $pref='';
my $pref2="";

if ($step eq "sflat") {$pref="sflt"}
elsif ($step eq "smooth") {$pref="sm"}
elsif ($step eq "fringe") {$pref="sfrg"; $pref2="objs"}
elsif ($step eq "detect") {$pref="objs"}
else {
  if (-e $$routlist) {system ("rm $$routlist")}
  if ($routlist2 ne '' && -e $$routlist2) {system ("rm $$routlist2")}
}


#Run SExtractor

if ($pref ne '' && (rindex($$routlist, '.fits')==-1 ) ) { 
    # called to make superflat or fringe frame
    $$routlist=mkOutList($inlist, $pref);
     
    system ("rm $$routlist") if (-e $$routlist);
    if ($routlist2 ne '') {
      $$routlist2=mkOutList($inlist, $pref2);
      system ("rm $$routlist2") if (-e $$routlist2)
    }
     
    my @ifiles=(); my @ofiles=();
    my $dfiles=0;    

    open (IFILE, $inlist);
    open (OFILE, ">$$routlist");

    if ($routlist2 ne '') {open (OFILE2, ">$$routlist2")}

    while (<IFILE>) {
       my $line=$_;
       chomp ($line);
       next if ($line eq "");
      my @info=split(/\t/, $line);
      my $ifile=$info[0]; chomp ($ifile); 
      $ifile=~tr/ //d;
      push @ifiles, $ifile;
      my @s=split(/\./, $ifile);
      $s[-3]=$s[-3].'-'.$pref;
      $info[0]=join '.', @s;
      push @ofiles, $info[0];
      $line=join("\t", @info);
      print OFILE "$line\n";
      $dfiles++ if (-e "info[0]");
 
      if ($routlist2 ne '') {
	$s[-3]=$s[-3].'-'.$pref2;	
	$info[0]=join '.', @s;
	$ofiles[-1]=$ofiles[-1].','.$info[0];
        $line=join("\t", @info);
         print OFILE2 "$line\n";
     }

     }
 
    close (IFILE);  
    close (OFILE);

   if ($routlist2 ne '') {close (OFILE2)}

# ======    Keep track of the list 
  &main::SumList($$routlist, 'SExtractor', $step, $#ofiles+1, $dfiles);

     
   for (my $i=0;$i<=$#ifiles; $i++) {
       my $in=$ifiles[$i];  my $out=$ofiles[$i];              
	   $ret=execSEx($in, $out, $chimtype);
           
       my $pc=int(100*($i+1)/($#ifiles+1)+0.5);
       if ($step) {my @s=split('/', $in);   print "counter $pc $s[-1]\n";}
     if ($main::CLEAN eq 'yes' && $ret==0 && $step eq 'sflat') {
       if ($main::DEBUG) {print "#DEBUG removing $in"}
       system ("rm $in");
       } 
   } 

} else {
#it is just one file
my $ofile=$$routlist;
if ($routlist2 ne '') {$ofile=$ofile.','.$$routlist2}

 $ret=execSEx($inlist, $ofile, $chimtype, $options);
}


return ($ret);

}

sub mkConfig {

 my $step=shift;

#Create the configuration file for SExtractor looking for the proper
#keywords according to the given step (fringe/sfringe/sflat)


my $chimtype='';
my $options='';

if ($step eq 'sflat' || $step eq 'smooth') {
# Compute the background to build the superflat
  $options="-BACK_SIZE ".$main::params->{sflat}{backsize}{Value};
#  my $entry;
#  foreach $entry (@SExConf) { 
#   if (exists $entry->{KEY}) {
#      my $key=$entry->{KEY};
#       if ($key eq 'BACK_SIZE') {
#        $entry->{VAL}=$main::params->{sflat}{backsize}{Value};
#            last;
#	  }
#      }
#    }         
   $chimtype='BACKGROUND';

} elsif ($step eq 'fringe' || $step eq 'sfringe') {
# Compute Frame-background  to build the master fringe 

#  my $entry;
#  foreach $entry (@SExConf) {
#   if (exists $entry->{KEY}) {
#       my $key=$entry->{KEY};  
##       if ($key eq 'DETECT_MINAREA') {
##            $entry->{VAL}=$main::params->{fringe}{det_area}{Value};
##	  }  
##       elsif ($key eq 'DETECT_THRESH') {
##             $entry->{VAL}=$main::params->{fringe}{det_thresh}{Value};
##	   }  
#       if ($key eq 'BACK_SIZE') {
#             $entry->{VAL}=$main::params->{fringe}{backsize}{Value};
#	  }
#      }
#   }       
   #$chimtype='-OBJECTS';
  $options=" -BACK_SIZE ".$main::params->{fringe}{backsize}{Value};
  $options=$options." -DETECT_THRESH ".$main::params->{fringe}{det_thresh}{Value};
 # $options=$options." -DETECT_MINAREA ".$main::params->{fringe}{det_area}{Value};
  $chimtype='-BACKGROUND,OBJECTS';

 }
 elsif ($step eq 'detect') {
  $options="-DETECT_THRESH 10";
  $chimtype='OBJECTS';
} 


#Actually create the configuration files (.conf + .params)
if (-e $main::SExConf) {system ("rm $main::SExConf")}
   &mkSExConf($main::SExConf);
#check for the existence of parameters file, in case create them
if (! -e $main::SExPars) {&mkSExPars($main::SExPars)}
#if (! -e $main::SExConv) {&mkSExConv($main::SExConv)}

return ($chimtype, $options);

}  #end sub MkConfig



sub execSEx {

my ($infile, $outfile, $chimtype, $options)=@_;

return if ($main::redmode eq "mklists");

my $task='SEx';


  my $ustop=0;

  
    if (!-e $infile) {  
            my $msg="input file $infile not found !";
	    &main::mkLog($msg,"E",$task);
	    return;
          }
    else {          
   
         	   
	  if (-e $outfile) {  
            if ($main::REDO eq 'yes') {
                    my $msg="output file $outfile exists, deleting";
                    &main::mkLog($msg,"W",$task);
                    system ("rm $outfile");
                   }
             else {	 
	            my $msg=" $outfile exists, skipped";	               
		    &main::mkLog($msg,"W",$task);
                     return;
		   }   
              }
   return if $main::redmode eq "listonly";
   
    if (-e "tmp.log") {system ("rm tmp.log")}
   #save normal STDERR and STDOUT
     open SAVEERR, ">&STDERR";
     open SAVEOUT, ">&STDOUT";
   #redirect to file
     open (STDERR, ">tmp.log");
     open (STDOUT, ">>tmp.log"); 
          

       my $cmd="$main::SExbin -c $main::SExConf ".$infile." -CHECKIMAGE_TYPE ".$chimtype." -CHECKIMAGE_NAME $outfile".' '.$options ;

	    # $cmd=$cmd." -CHECKIMAGE_NAME $outfile";
warn "$cmd";	
     
   # begin interrupt handling
           my $pid = open(KID_TO_WRITE, "|-");
           $SIG{ALRM} = sub {die "whoops,  pipe broke" };

           if ($pid) {  # parent
               my @data;
               for (@data) {
                   print KID_TO_WRITE;
               }
               if (!close(KID_TO_WRITE)) {warn "SEXTRACTOR stopped !!\n"; $ustop=1}

           } else {     # child
             #  ($EUID, $EGID) = ($UID, $GID);
               exec($cmd)
                   || die "can't exec $cmd: $!";               		   
               # NOTREACHED
           }
    #end interrupt handling   
           
        if ($ustop == 1) {last}
    
      # push(@outsoft,$out);
   } #end of else
  
  
#  my $pc=int(100*$i/$#ifiles+0.5);  
#  if ($main::interface eq 'gui') { 
#   system ("echo counter $pc >> $main::PIPEFILE");
#  } else{ printf "Processed files: %.0f%s\n",$pc,'%'} 
    
close (STDERR);
close (STDOUT);

#restore STDERR and STDOUT
 open STDERR, ">& SAVEERR";
 open STDOUT, ">& SAVEOUT";

#scan the ouput and look for errors

  open (OFILE, "tmp.log");
     my @outsoft=<OFILE>;
  close(OFILE);

 
my @errs=();
my @warns=();


#if ($ustop == 1) {
#  @errs=("ERROR: process stopped by user !");
#}
#else {  
  @errs=grep(/ERROR/, @outsoft);
  @warns=grep(/WARNING/, @outsoft);
#} 

 my $nwarn=scalar(@warns);
 my $nerr=scalar(@errs);

  if ($nerr !=0 || $nwarn !=0) {
     if ($nerr !=0) {
         foreach my $err (@errs) {
            my @string=split(/\*ERROR\*:/,$err,2);
	        my $l="ERROR: $string[1]"; 
             if ($main::interface eq 'gui' && Exists($main::checktop)) {
                  $main::checklist->insert('end',$l );
               }
	     else {print "$l\n";}  
          }
      }
      
    #   if ($nwarn !=0) {
    #     print OFILE "$nwarn WARNINGS\n";
    #     foreach my $warn (@warns) {
    #        my @string=split(/Warning:/,$warn,2);
    #        print OFILE "$string[1]\n";
    #      }
    #  }
 }

return ($nerr);

} #end sub RunSEx 



sub mkOutList {

my ($inlist, $pref)=@_;

#create a sbck-xxx list from a xxx list

  #take only filename without path
  my @string=split(/\//,$inlist);
  # add sbck-
  $string[-1]=$pref.'-'.$string[-1];
  #rebuild the complete filename
  my $toutlist=join ('/', @string);

return $toutlist;

} #end sub mkOutList

1;
