#!/usr/local/bin/perl

#package setdata;
  use CFITSIO qw( :longnames :constants);
  use Common::fitsio;

  use Cwd;
  use strict;

use vars qw/$pi/;

sub setdata
  {
 #    use mklist;
   
#
     my $indir=cwd;
     if (not &getTree(\$indir,"Please select the directory containing the TRUE data")) {return};
  
    if (!-d $indir) {
	$main::top->Dialog(
            -title  => 'ERROR !!!',
            -text   => "Can't find dir $indir",
            -bitmap => 'error',
        )->Show;
	return;
     }

     my $outdir=cwd;

     my $out_msg="Please select a directory where links should be created";


     if (not &getTree(\$outdir, $out_msg)) { return};
 
   if (!-x $outdir) {
	$main::top->Dialog(
            -title  => 'ERROR !!!',
            -text   => "Can't write to dir $outdir",
            -bitmap => 'error',
        )->Show;
	return
     }
 
   if (!-d $outdir) {
	$main::top->Dialog(
            -title  => 'ERROR !!!',
            -text   => "Can't find $outdir",
            -bitmap => 'error',
        )->Show;
	return
     }


     
 
   $main::seldir=$outdir;  

   if (!-d $indir || !-d $outdir) {print "something wrong....\n"; return};

# Draw the buttons to decide if really proceed or not
 my $app= $main::top->Toplevel;;
 $app->title('SetData: choice');



 my $lab=$app->Label(-text => 'Please choose what to do and then press OK');
  $lab->pack(qw/-side top/);

 my @pl = qw/-side top -pady 2 -anchor w/;

 my $choice="mkDB";

 $app->Radiobutton(
     -text     => "Do everything (links and database)",
     -variable => \$choice,
     -relief   => 'flat',
     -value    => "ALL",
 )->pack(@pl);

      
 $app->Radiobutton(
     -text     => "Only make the database",
     -variable => \$choice,
     -relief   => 'flat',
     -value    => "mkDB",
 )->pack(@pl); 

 $app->Radiobutton(
     -text     => "Forget it",
     -variable => \$choice,
     -relief   => 'flat',
     -value    => "quit",
 )->pack(@pl);

my $cancel = $app->Button(
                                 "-text" => "OK",
                                 "-command" =>
                                 sub {$app->destroy; }
                                );
  $cancel->pack(-side => 'top');

$app->waitWindow;

  if ($choice ne "quit") {&sdmain($indir, $outdir)};
  if ($choice eq "ALL") {&mktree($indir, $outdir)};
  }


sub sdmain {

my $START_SCRIPT_DIR=shift;
my $TOPDIR=shift;


# first release : gimi [27 July 1999]
#
# WHAT THIS SCRIPT DOES:
#  BASICALLY, for each file under a directory you select
#    say /some/absolute/path/this.fits
#  it builds an other path to the SAME file, but corresponding 
#         to an other organisation of files
#    say /other/absolute_path/smart/and/convenient/this.fits
#
# the only common things is the very last item "this.fits"
#
#======================================================================
# history : 
# release 1 : this script works for CFH fits header software.
#             the fits header is assumed to be written in 1 single line,
#             with each item written on 80 characters
# 
#         1.1 : to be compatible with FLIPS 
#                 (J-C CUILLANDRE : http://terapix.iap.fr/flips )
#                 add the mosaic part in image directory (R. MAOLI)
#        1.5 : changed by M. Radovich to be included in the PERL interface
#              dark and bias frames for all filters are put into separate directories
#              date is selected from local time, not UT, BUT currently this works only for CFHT
#              added exptime directory
#======================================================================
#  WHAT THE USER SHOULD KNOW TO RUN THIS SCRIPT
#
# there are IMPORTANTS directory names :
#	-1 $START_SCRIPT_DIR  = the directory from where you start the script.
#                                it contains at least all the files and subdir
#                                that you want to re-organise
#	-2 $TOPDIR = the directory you decide to put your re-organisation,
#                    you must have write access to it
#=======================================================================
#  to do : - interactive setting for character replacement 
#            for example : ask for deleting/replace "comma","single space"
#          - automatic selection of fits header type [CFH, ESO, ...]
#__________________________________________________________________
# CONSTANT used :
#$pi=4.*atan2(1,1); # since tan(pi/4)=1
#print "pi = $pi\n";
#my $fix80=80; #initialize width field (fixed by data FITS software )
#print "FITS software write pieces of $fix80 characters long\n";
#$delta_max_minute=7; # initialize max delta for same object
#print "max delta for same object = $delta_max_minute minutes\n";
#$delta_max_radian=$delta_max_minute*$pi/60/180;
#__________________________________________________________________

if ( -d $START_SCRIPT_DIR){chdir $START_SCRIPT_DIR;print `pwd`}
else {print "$START_SCRIPT_DIR NOT FOUND : exit script\n";}
##chomp($START_SCRIPT_DIR=`pwd`); # tell the script where you start
##                                # chop off (chomp) for safety ...
print "\n\nthis script now start from the directory $START_SCRIPT_DIR\n\n";

#chomp($TOPDIR=<STDIN>); # VERY IMPORTANT TO CHOP OFF
if ( !-d $TOPDIR){      # check if TOPDIR is a directory
print "ERROR ? MISTAKE ? need a coffee ? : $TOPDIR DO NOT EXIST. bye!\n";
exit;}# wrong dir
if ( !-x $TOPDIR){      # check if TOPDIR is writable by user
print "ERROR : $TOPDIR is not WRITABLE by you !!!\n";
exit;}
#__________________________________________________________________
# OK ; on continue
# on utilise les commandes unix depuis perl ;
#  le resultat de la commande unix "find" est piped, et devient le 
# fichier d'entree de I_FOUND . I_FOUND est un fichier de lignes, ou
#    chaque ligne est un nom de fichier. [ nom relatif a START_SCRIPT_DIR ]
open(I_FOUND,"find . -name '*' -print |")||\
die "putain de commande find qui merde : gloups ...\n";
# I_FOUND is red line by line until the end

#-------------------------------------------------------------------------

my $dblog=$TOPDIR."/".$main::SDFILE;
print "Creating database in $dblog\n";
open (DBFILE, "> $dblog");  #This is the database file
my $row=join ' # ', 'Nr','Detector','RunID','Filedir','object','RA','DEC',
      'DATE','LTDATE', ,'LT', 'Filter', 'Exp, 'Warnings';

print DBFILE "$row\n";

my $hinfo;

if ($main::INSTRUMENT eq 'CFH12K') {
    require Instr::cfh12k;
    $hinfo=cfh12k->new();
    $hinfo->init();
   }
elsif ($main::INSTRUMENT eq 'ESOWFI') {
     require Instr::esowfi;
     $hinfo=esowfi->new();
     $hinfo->init();
}


my $seqnr=1;

my ($FULL_LINK_NAME,$FULL_NAME ) ;

############################################################################
#
my $NAME;
                                            # BEGIN loop on files found
while ($NAME = <I_FOUND>)
{
chomp($NAME);
# chomp : chop off the last char if & only if it is "EOL" [ End Of Line]
# each name is a file or directory relative to current directory
#if( -d $NAME){print "DIRECTORY $NAME\n"}# NAME is a directory ; do nothing
if( -f $NAME)
{# NAME est un fichier, alors :  ....................... open hudge bracket
#       on "open" ce fichier, 

#   we need to know the name of the file itself, WITHOUT upper directories.
# to do so, we first remark that from the START_SCRIPT_DIR directory, NAME appears 
#    as "./dir1/dir2/.../dirn/file.fits", with leading dot
#----
# we want to get the very end part : END_NAME
#
my @allsubdir=reverse(split(/\//,$NAME)); #get a vector of string, with last
#                             element of vector being the string we want ; 
#                             so we reverse, then take the first
#                             may be the "pop" routine could do the job too 
my $END_NAME=$allsubdir[0];


if ($END_NAME !~ /fits$/i) {next}  #skip if it is not a fits file 

#if $END_NAME does not start with a number), than it is likely an average

my @warnings=();

if ($END_NAME !~ /\A[0-9]/) {my $comm='Average ?'; push(@warnings,$comm) } 

#open(CURRENT_FILE,$NAME);
# puis on lit seulement la premiere ligne du fichier ; cette seule ligne
#      contient TOUT le HEADER (jusqu'a + de 10000 caracteres)
#      on range cette ligne dans une variable, que l'on examine ensuite.
# Il est important de savoir que les HEADER sont construits sur UNE seule ligne
#      en CONCATENANT des morceaux de 80 caracteres (fix80) de long, 
#      sans aucun caractere EOL entre les morceaux : 
#      c'est pour cela qu'ils sont visibles avec la commande
#      "unix more" si et ssi la fenetre fait 80 caracteres de large 
#      (sinon, cela se decale)

#my $header=<CURRENT_FILE>;
#print " $header\n";
#my $length_header=length($header);# need the header length for the loop stop
#my $offset=0; #initialize offset for loop begin

#------------------------------------------------------------------------------
# samples of key to search for
#DETECTOR= 'CFH12K '            / CFHT 12K x 8K Mosaic CCD camera
#RUNID   = 'F41    '  
#FILTER  = 'V      '            / Name of filter in position
#DATE    = '1999-05-16T11:41:01' / UTC Date of file creation
#OBJECT  = 'Dome Flat V'  
#FILENAME= '485902o'            / Base filename at acquisition
#------------------------------------------------------------------------------


   $hinfo->Read($NAME);

   if ($main::INSTRUMENT eq 'CFH12K') {
       next if $hinfo->IMAGEID > 0
   }

#/////////////////////////////////////////////////////////////////////////////
# Here starts the analysis to find inconsistencies
#store the original name in the header (it may be changed in the following steps)

my $obstype=$hinfo->OBSTYPE;

if ($obstype eq "DARK" or $obstype eq "BIAS") {
#if BIAS or DARK, check for exposure time 
# (if Dark with 0s, it is a bias; conversely, if Bias with not 0s it is a Dark)
  {if ($hinfo->EXPTIME == 0) {
         if ($obstype ne "BIAS") {my $comm="# $obstype changed to BIAS";push(@warnings,$comm)}
	   $obstype = "BIAS"}
  else {if ($exptime != 0) {
         if ($obstype ne "DARK") {my $comm="# $obstype changed to DARK";push(@warnings,$comm)}
             $obstype = "DARK"}
	   }
	}

     $hinfo->OBJECT("");
     $hinfo->FILTER($obstype);
}

#   if ($hobj !~  /$object/i) {my $comm="# Name changed (was $hobj)"; push(@warnings,$comm)}


#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# STILL IN DEVELOPMENT
#Store infos in the database only if it is the last chip, and the file is a fits 


  my $row=$hinfo->mkSummary(' # ');

   if ($row ne '') {
      print DBFILE "$seqnr $row # @warnings\n";
       $seqnr++;
   }


}#                                                   END loop on files found
close(I_FOUND);
#close(LOG_FILES_AND_LINKS);
close (DBFILE);

chdir ($TOPDIR);

print "SetData finished !\n";

}


1;

