#!/usr/local/bin/perl

#package setdata;
  
  use Cwd;
  use strict;

use vars qw/$pi/;

sub setdata
  {
 #    use mklist;
   
#
     my $indir=cwd;
     if (not &getTree(\$indir,"Please select the directory containing the TRUE data")) {return};
  
    if (!-d $indir) {
	$main::top->Dialog(
            -title  => 'ERROR !!!',
            -text   => "Can't find dir $indir",
            -bitmap => 'error',
        )->Show;
	return;
     }

     my $outdir=cwd;

     my $out_msg="Please select a directory where links should be created";


     if (not &getTree(\$outdir, $out_msg)) { return};
 
   if (!-x $outdir) {
	$main::top->Dialog(
            -title  => 'ERROR !!!',
            -text   => "Can't write to dir $outdir",
            -bitmap => 'error',
        )->Show;
	return
     }
 
   if (!-d $outdir) {
	$main::top->Dialog(
            -title  => 'ERROR !!!',
            -text   => "Can't find $outdir",
            -bitmap => 'error',
        )->Show;
	return
     }


     
 
   $main::seldir=$outdir;  

   if (!-d $indir || !-d $outdir) {print "something wrong....\n"; return};

# Draw the buttons to decide if really proceed or not
 my $app= $main::top->Toplevel;;
 $app->title('SetData: choice');



 my $lab=$app->Label(-text => 'Please choose what to do and then press OK');
  $lab->pack(qw/-side top/);

 my @pl = qw/-side top -pady 2 -anchor w/;
 
 my $choice="REAL";

 $app->Radiobutton(
     -text     => "Do everything (links and database)",
     -variable => \$choice,
     -relief   => 'flat',
     -value    => "REAL",
 )->pack(@pl);

      
 $app->Radiobutton(
     -text     => "Only make the database",
     -variable => \$choice,
     -relief   => 'flat',
     -value    => "test",
 )->pack(@pl); 

 $app->Radiobutton(
     -text     => "Forget it",
     -variable => \$choice,
     -relief   => 'flat',
     -value    => "quit",
 )->pack(@pl);

my $cancel = $app->Button(
                                 "-text" => "OK",
                                 "-command" =>
                                 sub {$app->destroy; }
                                );
  $cancel->pack(-side => 'top');

$app->waitWindow;

  if ($choice ne "quit") {&sdmain($indir, $outdir, $choice)};
  }


sub sdmain {

my $START_SCRIPT_DIR=shift;
my $TOPDIR=shift;
my $choice = shift;


# first release : gimi [27 July 1999]
#
# WHAT THIS SCRIPT DOES:
#  BASICALLY, for each file under a directory you select
#    say /some/absolute/path/this.fits
#  it builds an other path to the SAME file, but corresponding 
#         to an other organisation of files
#    say /other/absolute_path/smart/and/convenient/this.fits
#
# the only common things is the very last item "this.fits"
#
#======================================================================
# history : 
# release 1 : this script works for CFH fits header software.
#             the fits header is assumed to be written in 1 single line,
#             with each item written on 80 characters
# 
#         1.1 : to be compatible with FLIPS 
#                 (J-C CUILLANDRE : http://terapix.iap.fr/flips )
#                 add the mosaic part in image directory (R. MAOLI)
#        1.5 : changed by M. Radovich to be included in the PERL interface
#              dark and bias frames for all filters are put into separate directories
#              date is selected from local time, not UT, BUT currently this works only for CFHT
#              added exptime directory
#======================================================================
#  WHAT THE USER SHOULD KNOW TO RUN THIS SCRIPT
#
# there are IMPORTANTS directory names :
#	-1 $START_SCRIPT_DIR  = the directory from where you start the script.
#                                it contains at least all the files and subdir
#                                that you want to re-organise
#	-2 $TOPDIR = the directory you decide to put your re-organisation,
#                    you must have write access to it
#=======================================================================
#  to do : - interactive setting for character replacement 
#            for example : ask for deleting/replace "comma","single space"
#          - automatic selection of fits header type [CFH, ESO, ...]
#__________________________________________________________________
# CONSTANT used :
$pi=4.*atan2(1,1); # since tan(pi/4)=1
#print "pi = $pi\n";
my $fix80=80; #initialize width field (fixed by data FITS software )
#print "FITS software write pieces of $fix80 characters long\n";
#$delta_max_minute=7; # initialize max delta for same object
#print "max delta for same object = $delta_max_minute minutes\n";
#$delta_max_radian=$delta_max_minute*$pi/60/180;
#__________________________________________________________________

if ( -d $START_SCRIPT_DIR){chdir $START_SCRIPT_DIR;print `pwd`}
else {print "$START_SCRIPT_DIR NOT FOUND : exit script\n";}
##chomp($START_SCRIPT_DIR=`pwd`); # tell the script where you start
##                                # chop off (chomp) for safety ...
print "\n\nthis script now start from the directory $START_SCRIPT_DIR\n\n";

#chomp($TOPDIR=<STDIN>); # VERY IMPORTANT TO CHOP OFF
if ( !-d $TOPDIR){      # check if TOPDIR is a directory
print "ERROR ? MISTAKE ? need a coffee ? : $TOPDIR DO NOT EXIST. bye!\n";
exit;}# wrong dir
if ( !-x $TOPDIR){      # check if TOPDIR is writable by user
print "ERROR : $TOPDIR is not WRITABLE by you !!!\n";
exit;}
#__________________________________________________________________
# OK ; on continue
# on utilise les commandes unix depuis perl ;
#  le resultat de la commande unix "find" est piped, et devient le 
# fichier d'entree de I_FOUND . I_FOUND est un fichier de lignes, ou
#    chaque ligne est un nom de fichier. [ nom relatif a START_SCRIPT_DIR ]
open(I_FOUND,"find . -name '*' -print |")
 or die "something wrong with  command find\n";
# I_FOUND is red line by line until the end
#-------------------------------------------------------------------------
# concerning log file : a time stamp is included in the log file,
#    allowing multi runs
my ($sec,$min,$hour,$mday,$mon,@dontcare)= localtime (time);
my ($now) = sprintf ("%2.2d.%2.2d-%2.2d%2.2d%2.2d",$mday,$mon+1,$hour,$min,$sec);
my $logfilename=$TOPDIR."/"."-".$now.".log";
#  my $logfilename=$TOPDIR."/".file_and_links."-".$now.".log";
print "log file is : $logfilename\n";
#-------------------------------------------------------------------------

my $dblog=$TOPDIR."/".$main::SDFILE;
print "Creating database in $dblog\n";
open (DBFILE, "> $dblog");  #This is the database file
print DBFILE "Nr \t Detector \t RunID \t Filedir \t object \t RA \t DEC \t DATE \t LT \t UT \t Filter \t Exp \t Warnings\n";

my $seqnr=1;

my ($FULL_LINK_NAME,$FULL_NAME ) ;

open(LOG_FILES_AND_LINKS,">$logfilename");# log file of this script
#                                           only to control what was done.
############################################################################
#
my $NAME;
                                            # BEGIN loop on files found
while ($NAME = <I_FOUND>)
{
chomp($NAME);
# chomp : chop off the last char if & only if it is "EOL" [ End Of Line]
# each name is a file or directory relative to current directory
#if( -d $NAME){print "DIRECTORY $NAME\n"}# NAME is a directory ; do nothing
if( -f $NAME)
{# NAME est un fichier, alors :  ....................... open hudge bracket
#       on "open" ce fichier, 

#   we need to know the name of the file itself, WITHOUT upper directories.
# to do so, we first remark that from the START_SCRIPT_DIR directory, NAME appears 
#    as "./dir1/dir2/.../dirn/file.fits", with leading dot
#----
# we want to get the very end part : END_NAME
#
my @allsubdir=reverse(split(/\//,$NAME)); #get a vector of string, with last
#                             element of vector being the string we want ; 
#                             so we reverse, then take the first
#                             may be the "pop" routine could do the job too 
my $END_NAME=$allsubdir[0];


if ($END_NAME !~ /fits$/i) {next}  #skip if it is not a fits file 

#if $END_NAME does not start with a number), than it is likely an average

my @warnings=();

if ($END_NAME !~ /\A[0-9]/) {my $comm='Average ?'; push(@warnings,$comm) } 

open(CURRENT_FILE,$NAME);
# puis on lit seulement la premiere ligne du fichier ; cette seule ligne
#      contient TOUT le HEADER (jusqu'a + de 10000 caracteres)
#      on range cette ligne dans une variable, que l'on examine ensuite.
# Il est important de savoir que les HEADER sont construits sur UNE seule ligne
#      en CONCATENANT des morceaux de 80 caracteres (fix80) de long, 
#      sans aucun caractere EOL entre les morceaux : 
#      c'est pour cela qu'ils sont visibles avec la commande
#      "unix more" si et ssi la fenetre fait 80 caracteres de large 
#      (sinon, cela se decale)

my $header=<CURRENT_FILE>;
#print " $header\n";
my $length_header=length($header);# need the header length for the loop stop
my $offset=0; #initialize offset for loop begin
#------------------------------------------------------------------------------
# samples of key to search for
#DETECTOR= 'CFH12K '            / CFHT 12K x 8K Mosaic CCD camera
#RUNID   = 'F41    '  
#FILTER  = 'V      '            / Name of filter in position
#DATE    = '1999-05-16T11:41:01' / UTC Date of file creation
#OBJECT  = 'Dome Flat V'  
#FILENAME= '485902o'            / Base filename at acquisition
#------------------------------------------------------------------------------

my ($sra, $ra, $sdec, $dec, $obstype, $exptime, $xexp,$detector, $runid, $filter );
my ($date, $HHMMSS, @HH, @loctime, $object, $chip,$filename, $dt, $ut12 ) ;


#---------------------------------------------------- BEGIN HEADER loop analyse
while ($offset < $length_header)
{$_=substr($header,$offset,$fix80);#take fix80 chars from position offset
# [the following section could be improved with if...elsif because
#  the "if" test can be succesfull on only ONE item at each loop]
#     also, may be safer to check at the begining of the string[ /^THE_KEY=/
#_________________________________________________


if (/RA      =/ )        #si la variable courante ($_ par defaut) 
                         #   contient la chaine "RA"
{                        # ALORS
my @string=split(/'/,$_,3); #decoupe en morceaux (3 maxi), selon le delimiteur "'"
$sra=$string[1];            # store ra in "string mode"
$ra=convert_RA($string[1]);     #assigne le 2eme morceau a la variable "objtype"
}
#_________________________________________________
elsif (/DEC     =/ )        #si la variable courante ($_ par defaut) 
                         #   contient la chaine "DEC"
{                        # ALORS
my @string=split(/'/,$_,3); #decoupe en morceaux (3 maxi), selon le delimiteur "'"
$sdec=$string[1];            # store dec in "string mode"
$dec=convert_DEC($string[1]);     #assigne le 2eme morceau a la variable "objtype"
}
#_______________________________________________
elsif (/OBSTYPE =/ )        #si la variable courante ($_ par defaut) 
                         #   contient la chaine "OBSTYPE"
{                        # ALORS
my @string=split(/'/,$_,3); #decoupe en morceaux (3 maxi), selon le delimiteur "'"
$obstype=$string[1];     #assigne le 2eme morceau a la variable "obstype"
$obstype=~ tr/ //d;      #et enleve les "espaces" ( translate " " to "" )
}
#_______________________________________________
elsif (/EXPTIME =/ )        #si la variable courante ($_ par defaut) 
                         #   contient la chaine "EXPTIME"
{                        # ALORS
my @string=split('/',$_,2); #decoupe en morceaux (2 maxi), selon le delimiteur "'"
my @sstring=split(/=/,$string[0],2); #decoupe en morceaux (2 maxi), selon le delimiteur "="
$exptime=$sstring[1];     #assigne le 2eme morceau a la variable "exptime"
@string=split('\.',$exptime,2); #take only integer part of time
$xexp=$string[0];
$xexp =~ tr/ //d;               # get rid of spaces
$xexp=$xexp.'s';                # convert into format "xxxs" 
}
#_________________________________________________
elsif (/DETECTOR=/ )        #si la variable courante ($_ par defaut) 
                         #   contient la chaine "DETECTOR"
{                        # ALORS
my @string=split(/'/,$_,3); #decoupe en morceaux (3 maxi), selon le delimiteur "'"
$detector=$string[1];    #assigne le 2eme morceau a la variable "detector"
$detector=~ tr/ //d;     #et enleve les "espaces" ( translate " " to "" )
                         # ATTENTION : le premier element a l'indice "0"
}                        #             le "~" doit coller au "="
#_________________________________________________
elsif (/RUNID   =/ ){
my @string=split(/'/,$_,3);
$runid=$string[1];
$runid=~ tr/ //d;
}#_________________________________________________
elsif (/FILTER  =/){
my @string=split(/'/,$_,3);
$filter=$string[1];
$filter=~ tr/ //d;
}#_________________________________________________
elsif (/DATE    =/ ){
my @string=split(/'/,$_,3);
($date,$HHMMSS)=split(/T/,$string[1],2); # les champs DATE et TIME sont separes
                                         # par la lettre "T"
@HH=split(/:/,$HHMMSS,2);  # $HHMMSS contient l'heure sous la forme HH:MM:SS
#if ($HH lt "12")  # selon la valeur de HH, on recule ou non la date


}#_________________________________________________

elsif (/HSTTIME =/ )        #si la variable courante ($_ par defaut) 
                         #   contient la chaine "DETECTOR"
{                        # ALORS
my @string=split(/'/,$_,3); #decoupe en morceaux (3 maxi), selon le delimiteur "'"
#$ldate=$string[1];
$_=$string[1];           # we get e.g. Mon May 10 00:56:17 HST 1999
@loctime=/(\d{2,2}):(\d{2,2}):(\d{2,2})/; #this keeps only hh, mm and ss


}
#_______________________________________________

elsif (/OBJECT  =/ ){
my @string=split(/'/,$_,3);
$object=$string[1];
$object=~ tr/ //d;
$object=~ tr/,/_/; # translate comma into underscore
$object=~ tr/0-9a-zA-Z_//c;# discard every characters but
                                          # digits, letters, underscore
                           # ATTENTION : "c" means "complement", so
           # this must be understood as : the complement of /0-9a-zA-Z_/
           #   is replaced by /nothing/
}#_________________________________________________
elsif (/IMAGEID =/ )     # read and store the number of the chip
{                        
my @string=split('/',$_,2);
my @sstring=split(/=/,$string[0],2);
$chip=$sstring[1];   
$chip =~ tr/ //d;               # get rid of spaces
} 
#_________________________________________________

elsif (/FILENAME=/ ){
my @string=split(/'/,$_,3);
$filename=$string[1];
$filename=~ tr/ //d;
$filename=~ tr/,/_/; 
$filename=~ tr/0-9a-zA-Z_//c;
}#_________________________________________________
$offset+=$fix80;  # shift the offset for next loop -   END HEADER loop analyse
}#----------------------------------------------------------------------------
#converts 12 of local time to UT
$dt=$HH[0]-$loctime[0];
if ($dt < 0) {$dt += 24.}
$ut12=12+$dt;
if ($HH[0] lt $ut12)  
{$date=&modif_date($date)}


if ($filename eq '') {next} #no file number found, this is not an image

#/////////////////////////////////////////////////////////////////////////////
# Here starts the analysis to find inconsistencies



#store the original name in the header (it may be changed in the following steps)
my $hobj=$object;

if ($obstype eq "DARK" or $obstype eq "BIAS") {
#if BIAS or DARK, check for exposure time 
# (if Dark with 0s, it is a bias; conversely, if Bias with not 0s it is a Dark)
  {if ($exptime == 0) {
         if ($obstype ne "BIAS") {my $comm="# $obstype changed to BIAS";push(@warnings,$comm)}
	   $obstype = "BIAS"}
  else {if ($exptime != 0) {
         if ($obstype ne "DARK") {my $comm="# $obstype changed to DARK";push(@warnings,$comm)}
             $obstype = "DARK"}
	   }
	}

    #my $ucob=uc($object);	
	
 #  if ($obstype !~  /$object/i) {my $comm="Not defined as $obstype"; push(@warnings,$comm)}
   
     $object="";
     $filter=$obstype;
}

   if ($hobj !~  /$object/i) {my $comm="# Name changed (was $hobj)"; push(@warnings,$comm)}


#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# STILL IN DEVELOPMENT
#Store infos in the database only if it is the last chip, and the file is a fits 

if ($chip == 0) {
    print DBFILE "$seqnr \t $detector \t $runid \t $filename \t $object \t $sra \t $sdec \t $date\t $loctime[0]:$loctime[1]:$loctime[2] \t $HHMMSS \t $filter \t $xexp \t @warnings\n";
    $seqnr++;
}
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
#THE FOLLOWING SECTION COULD BE RE_ARRANGED IN ORDER TO CONSTRUCT
#    A DIFFERENT ORGANISATION.
#  THE ACTUAL STRUCTURE IS :
# detector/runid/filter/date/object/exptime/filename 
# at last : concatenate ["dot" operator] small pieces including "/"
# $PARTIAL_LINK_DIR is simply the concatenate of pieces found in HEADER
my $PARTIAL_LINK_DIR=$detector."/".$runid."/".$filter."/".$date."/".$object."/".$xexp."/".$filename;
#$FULL_LINK_DIR is absolute, that is include TOPDIR
my $FULL_LINK_DIR=$TOPDIR."/".$PARTIAL_LINK_DIR;
if (!-d $FULL_LINK_DIR)# the directory do not exist
# so need to check/create all intermediate directories
{#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ BEGIN link check
my $LINKdetector=$TOPDIR."/".$detector;
if (!-d $LINKdetector)
{if ($choice eq 'REAL')
{  #print "create dir $LINKdetector\n";
mkdir ($LINKdetector,0755)}             # "755" means "rwxr-xr-x"
#else {print "would create dir $LINKdetector\n"}
}
#-----------------------------------------------
my $LINKrunid=$LINKdetector."/". $runid;
if (!-d $LINKrunid)
{if ($choice eq 'REAL')
{ #print "create dir $LINKrunid\n";
mkdir ($LINKrunid,0755)}
#else {print "would create dir $LINKrunid\n"}
}
#-----------------------------------------------
my $LINKfilter=$LINKrunid."/".$filter;
if (!-d $LINKfilter)
{if ($choice eq 'REAL')
{   #print "create dir $LINKfilter\n";
mkdir ($LINKfilter,0755)}
#else {print "would create dir $LINKfilter\n"}
}
#-----------------------------------------------
my $LINKdate=$LINKfilter."/".$date;
if (!-d $LINKdate)
{if ($choice eq 'REAL')
{    #print "create dir $LINKdate\n";
mkdir ($LINKdate,0755)}
#else {print "would create dir $LINKdate\n"}
}
#-----------------------------------------------
my $LINKobject=$LINKdate."/".$object;
if (!-d $LINKobject)
{if ($choice eq 'REAL')
{    #print "create dir $LINKobject\n";
mkdir ($LINKobject,0755)}
#else {print "would create dir $LINKobject\n"}
}
#-----------------------------------------------

my $LINKexptime=$LINKobject."/".$xexp;
if (!-d $LINKexptime)
{if ($choice eq 'REAL')
{    #print "create dir $LINKexptime\n";
mkdir ($LINKexptime,0755)}
#else {print "would create dir $LINKexptime\n"}
}
#-----------------------------------------------
my $LINKfilename=$LINKexptime."/".$filename;
if (!-d $LINKfilename)
{if ($choice eq 'REAL')
{    #print "create dir $LINKfilename\n";
mkdir ($LINKfilename,0755)}
#else {print "would create dir $LINKfilename\n"}
}
#-----------------------------------------------
#$LINKunknown=$LINKrunid."/unknown"; #separate directory for files not starting with a number (e.g. averaged frames)
#if (!-d $LINKunknown)
#{if ($choice eq REAL)
#{print "create dir $LINKunknown\n";
#mkdir ($LINKstelse,0755)}
#else {print "would create dir $LINKunknown\n"}}
#-----------------------------------------------
}#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++   END link check
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
#
# at this point, all subdirectories do exits ; 
#----

# we make the full_link_name:
   $FULL_LINK_NAME=$FULL_LINK_DIR."/".$END_NAME;
#
#-----
# also, the FULL_NAME is "START_SCRIPT_DIR/dir1/dir2/.../dirn/file.fits"
#  so we need to concatenate START_SCRIPT_DIR and NAME WITHOUT leading dot
   $NAME=~ s/^\.\//\//; # remove leading dot : "./foo" -> "/foo"
   $FULL_NAME=$START_SCRIPT_DIR.$NAME;
#
#-----
# NOW, WE HAVE EVERYTHING : FULL_NAME and FULL_LINK_NAME
#
   if ($choice eq 'REAL')
     {symlink($FULL_NAME,$FULL_LINK_NAME)}

}# ......................................................  close hudge bracket
close(CURRENT_FILE);
# write to the log file, whatever it is REAL or a try :
print LOG_FILES_AND_LINKS ($FULL_LINK_NAME," -> ",$FULL_NAME,"\n");
############################################################################
#$old_ra=$ra;
#$old_dec=$dec;
#$old_object=$object;

}#                                                   END loop on files found
close(I_FOUND);
close(LOG_FILES_AND_LINKS);
close (DBFILE);

chdir ($TOPDIR);

print "SetData finished !\n";

}

#==============================================================================
sub modif_date {
# this subroutine shift back the date of 1 day ; 
# the date is presented and returned as : YYYY-MM-DD
my ($olddate)=@_;

my $date;

my ($YEAR,$MONTH,$DAY)=split(/-/,$olddate); #
my ($newDAY, $newMONTH, $newYEAR);
if ($DAY gt "01") # this is NOT the first day of the month : only DAY is shifted
     {$newDAY=$DAY-1;
      $newDAY=sprintf "%02d",$newDAY;        # make sure to get 2 digits format
      $date=$YEAR ."-". $MONTH ."-". $newDAY;# concatenate to YYYY-MM-DD
     }
else {# this is the first day of the month, so DAY and MONTH are shifted
     if ($MONTH eq "01")
  {# HEY ! this is New Year's Day  !!! then shift also YEAR
   $newMONTH="12";
   $newDAY="31";
   $newYEAR=$YEAR-1; 
   $date=$newYEAR ."-". $newMONTH ."-". $newDAY;# concatenate to YYYY-MM-DD
  }
     else { # this is just a first day of other month than January, 
#             so shift the MONTH and DAY ...
      $newMONTH=$MONTH -1;
      $newMONTH=sprintf "%02d",$newMONTH;# 2 digits format
#  ... and then shift the day to the last day of the previous month ;
#  to calculate the last day of the previous, use an hash array
#    built as a serie of couples : first couple is "02","31"  and so on...
#    this must be understood as : "the last day of the previous month is that"
#    for instance : the current month is February(02), then the
#                     previous month is January, then last is 31

my (%jour);

my $flag=0;
if ($YEAR == 2000) {$flag=1} else {
  my $Y4=$YEAR/4.;
  if (int($Y4) == $Y4) {$flag=1}
}

if ($flag==1 ){# leap year - bissextile
      (%jour)= ("02","31","03","29","04","31","05","30","06","31","07","30","08","31","09","31","10","30","11","31","12","30");
                   }
              else {
      (%jour)= ("02","31","03","28","04","31","05","30","06","31","07","30","08","31","09","31","10","30","11","31","12","30");
                   }
      $date=$YEAR ."-". $newMONTH ."-". $jour{$MONTH};
     }
return $date;
}}
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub convert_RA {
# this subroutine takes in input the substring extracted from the HEADER
#RA      = '13:58:49.74'        / Right ascenion
# the substring is for example : "13:58:49.74" [in time  hour:minute:second]
# and transforms it into radian :
my ($RA)=@_; # assign the content of argument passed [@_] to a local variable
my ($hour,$minute,$second)=split(/:/,$RA);
# transform time into degrees :
#                            $hour   : * 15        (1h time = 15 degrees arc)
#                            $minute : * 15 / 60   (1' time = 15' arc)
#                            $sec    : * 15 / 3600 (1" time = 15" arc)
# then transform degrees into radian : * pi / 180
my $RA_rad=$pi * ($hour + $minute/60 + $second/3600)/12 ;  # 15/180 = 1/12
return $RA_rad;}
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub convert_DEC {
# this subroutine takes in input the substring extracted from the HEADER
#DEC     = '4:46:02.5'          / Declination
# the substring is for example : "4:46:02.5" [arc degree:minute:second]
# and transforms it into radian :
my ($DEC)=@_;# assign the content of argument passed [@_] to a local variable
my ($degree,$minute,$second)=split(/:/,$DEC);
# to transform into degrees :
#                             $degree   : as is
#                             $minute   : / 60
#                             $sec      : / 3600
# then to transform degrees into radian : * pi / 180
my $DEC_rad=$pi * ($degree + $minute/60 + $second/3600)/180;
return $DEC_rad;}

1;

