use WW::WWconf;

use strict;

sub doWW {

my $opt; $opt = pop @_ if ref($_[$#_]) eq 'HASH';

my (@inw, @minw, @maxw, @wflags, $outflag, $outweight);

my $inflag;



$outflag="";
$outweight="";
@inw=();
@minw=();
@maxw=();
@wflags=();

if (exists $opt->{FLAT} ) {
   push @inw, $$opt{FLAT};
   push @minw, 0.2;
   push @maxw, 1e30;  
   push @wflags, '0x04';  # set the 2nd bit 
}

if (exists $opt->{SCIENCE} ) {
   push @inw, $$opt{SCIENCE};
   push @minw, -1e30;
#   push @maxw,  $main::params->{select}{highrej}{Value};
    push @maxw, 50000;
   push @wflags, '0x01';  #set the 1st bit
}

if (exists $opt->{BPM} ) {
   $inflag=$$opt{BPM}
}

if (exists $opt->{MKWEIGHT} ) {
   $outweight=$$opt{MKWEIGHT}
}

if (exists $opt->{MKFLAG} ) {
   $outflag=$$opt{MKFLAG}
}


return -1 if ( ($outflag eq "" && $outweight eq "") || $#inw==-1);

$inflag='""' if ($inflag eq "");
@inw=('""') if ($#inw==-1);
$outflag='""' if ($outflag eq "");
$outweight='""' if ($outweight eq "");

#in order to make weight maps we need the flat and/or BPM



# === Initialize the conf. array 
&InitWW();

  my $entry;
  my $nfound=0;
  my $nkeys=7;   #How many keys should be set !!

  foreach $entry (@WWConf) { 
    if (exists $entry->{KEY}) {
      my $key=$entry->{KEY};     
    if ($key eq 'WEIGHT_NAMES') {
            $entry->{VAL}=join (',', @inw);
            $nfound++;
	  }  
      elsif ($key eq 'WEIGHT_MIN') {
            $entry->{VAL}=join (',', @minw);
            $nfound++;
	  }  
      elsif ($key eq 'WEIGHT_MAX') {
            $entry->{VAL}=join (',', @maxw);
            $nfound++;
	  }  
      elsif ($key eq 'WEIGHT_OUTFLAGS') {
            $entry->{VAL}=join (',', @wflags);
            $nfound++;
	  }  

    elsif ($key eq 'FLAG_NAMES') {
            $entry->{VAL}=$inflag;
	    $nfound++;
	  } 
    elsif ($key eq 'OUTWEIGHT_NAME') {
            $entry->{VAL}=$outweight;
	    $nfound++;
	  } 
    elsif ($key eq 'OUTFLAG_NAME') {
            $entry->{VAL}=$outflag;
	    $nfound++;
	  } 
    }
    last if ($nfound==$nkeys);
  }

# === Write the configuration file

&mkWWConf($main::WWConf);

# ==== Run WeightWatcher 

&execWW();

return 1;

}


sub execWW
{
#my ($infile, $outfile)=@_;


my $task='WW';


  my $ustop=0;

  
#    if (!-e $infile) {  
#            my $msg="input file $infile not found !";
#	    &main::mkLog($msg,"E",$task);
#	    return;
#          }
#    else {          
   
         	   
#	  if (-e $outfile) {  
#            if ($main::REDO eq 'yes') {
#                    my $msg="output file $outfile exists, deleting";
#                    &main::mkLog($msg,"W",$task);
#                    system ("rm $outfile");
#                   }
#             else {	 
#	            my $msg=" $outfile exists, skipped";	               
#		    &main::mkLog($msg,"W",$task);
#                     return;
#		   }   
#              }
   return if $main::redmode eq "listonly";
   
    if (-e "tmp.log") {system ("rm tmp.log")}
   #save normal STDERR and STDOUT
     open SAVEERR, ">&STDERR";
     open SAVEOUT, ">&STDOUT";
   #redirect to file
     open (STDERR, ">tmp.log");
     open (STDOUT, ">>tmp.log"); 
          

       my $cmd="$main::WWbin -c $main::WWConf ";
	     
   # begin interrupt handling
           my $pid = open(KID_TO_WRITE, "|-");
           $SIG{ALRM} = sub {die "whoops,  pipe broke" };

           if ($pid) {  # parent
               my @data;
               for (@data) {
                   print KID_TO_WRITE;
               }
               if (!close(KID_TO_WRITE)) {warn "WW stopped !!\n"; $ustop=1}

           } else {     # child
             #  ($EUID, $EGID) = ($UID, $GID);
               exec($cmd)
                   || die "can't exec $cmd: $!";               		   
               # NOTREACHED
           }
    #end interrupt handling   
           
     #   if ($ustop == 1) {last}
    
      # push(@outsoft,$out);
#   } #end of else
  
  

   
close (STDERR);
close (STDOUT);

#restore STDERR and STDOUT
 open STDERR, ">& SAVEERR";
 open STDOUT, ">& SAVEOUT";

#scan the ouput and look for errors

  open (OFILE, "tmp.log");
     my @outsoft=<OFILE>;
  close(OFILE);

 
my @errs=();
my @warns=();

  @errs=grep(/ERROR/, @outsoft);
  @warns=grep(/WARNING/, @outsoft);


 my $nwarn=scalar(@warns);
 my $nerr=scalar(@errs);

  if ($nerr !=0 || $nwarn !=0) {
     if ($nerr !=0) {
         foreach my $err (@errs) {
            my @string=split(/\*ERROR\*:/,$err,2);
	        my $l="ERROR: $string[1]"; 
#             if ($main::interface eq 'gui' && Exists($main::checktop)) {
#                  $main::checklist->insert('end',$l );
#               }
#	     else {print "$l\n";}  
          }
      }
      
 }

return ($nerr);

}

1;
