#bench1a : threading on a transposed PDL
# same as bench1, but part of the operation is made only once
# a) Transpose PDL, make operation and transpose back                              13s
# b) Create a child PDl, transpose it and make the (backword assigned) operation   14s
# c) Create a child PDl, transpose it and make the (backword assigned) operation
#    using an inplace operator                                                     10s



use PDL;
 use Benchmark;

$a=float[[1,2,3],[3,4,5]];
$b=float[[-1,240,330],[3,490,50]];

$stack=zeroes(float,3,2,2);

($tmp=$stack->slice(':,:,0')) .= $a;
($tmp=$stack->slice(':,:,1')) .= $b;

$scalf=zeroes(float,2);

set ($scalf,0,avg($a));
set ($scalf,1,avg($b));

$mmed= average($scalf)/$scalf ;

$count=10000;

$t=timeit($count, '$s=$stack->copy;$s=($s->mv(2,0)*$mmed)->mv(0,2)');
  print "\n$count loops of (a) code took:",timestr($t),"\n";
  print "$scalf\n";
print "$mmed \n";
print "$s\n";



$t=timeit($count, '$s=$stack->copy;my $tmp;$tmp=$s->mv(2,0); $tmp .= $tmp*$mmed');

  print "$count loops of (b) code took:",timestr($t),"\n";
  print "$scalf\n";
print "$mmed \n";
print "$s\n";


$t=timeit($count, '$s=$stack->copy;my $tmp;$tmp=$s->mv(2,0); $tmp*=$mmed');


  print "$count loops of (c) code took:",timestr($t),"\n";
  print "$scalf\n";
print "$mmed \n";
print "$s\n";
